/*********************************************************************

  Hisilicon dsa fabric driver
  Copyright(c) 2014 - 2019 Huawei Corporation.

  This program is free software; you can redistribute it and/or modify it
  under the terms and conditions of the GNU General Public License,
  version 2, as published by the Free Software Foundation.

  This program is distributed in the hope it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin St - Fifth Floor, Boston, MA 02110-1301 USA.

  The full GNU General Public License is included in this distribution in
  the file called "COPYING".

  Contact Information:TBD

**********************************************************************/
#ifndef _IWARE_DSAF_REG_OFFSET_H_
#define _IWARE_DSAF_REG_OFFSET_H_

#define DSAF_SRAM_INIT_OVER_0_REG	(0x0)
#define DSAF_CFG_0_REG			(0x4)
#define DSAF_ECC_ERR_INVERT_0_REG	(0x8)
#define DSAF_ABNORMAL_TIMEOUT_0_REG	(0x1C)
#define DSAF_FSM_TIMEOUT_0_REG		(0x20)
#define DSAF_DSA_REG_CNT_CLR_CE_REG	(0x2C)
#define DSAF_DSA_SBM_INF_FIFO_THRD_REG	(0x30)
#define DSAF_DSA_SRAM_1BIT_ECC_SEL_REG	(0x34)
#define DSAF_DSA_SRAM_1BIT_ECC_CNT_REG	(0x38)
#define DSAF_PFC_EN_0_REG			(0x50)
#define DSAF_PFC_EN_1_REG			(0x54)
#define DSAF_PFC_EN_2_REG			(0x58)
#define DSAF_PFC_EN_3_REG			(0x5C)
#define DSAF_PFC_EN_4_REG			(0x60)
#define DSAF_PFC_EN_5_REG			(0x64)
#define DSAF_PFC_UNIT_CNT_0_REG		 (0x70)
#define DSAF_PFC_UNIT_CNT_1_REG		 (0x74)
#define DSAF_PFC_UNIT_CNT_2_REG		 (0x78)
#define DSAF_PFC_UNIT_CNT_3_REG		 (0x7C)
#define DSAF_PFC_UNIT_CNT_4_REG		 (0x80)
#define DSAF_PFC_UNIT_CNT_5_REG		 (0x84)
#define DSAF_XGE_INT_MSK_0_REG		  (0x100)
#define DSAF_XGE_INT_MSK_1_REG		  (0x104)
#define DSAF_XGE_INT_MSK_2_REG		  (0x108)
#define DSAF_XGE_INT_MSK_3_REG		  (0x10C)
#define DSAF_XGE_INT_MSK_4_REG		  (0x110)
#define DSAF_XGE_INT_MSK_5_REG		  (0x114)
#define DSAF_PPE_INT_MSK_0_REG		  (0x120)
#define DSAF_PPE_INT_MSK_1_REG		  (0x124)
#define DSAF_PPE_INT_MSK_2_REG		  (0x128)
#define DSAF_PPE_INT_MSK_3_REG		  (0x12C)
#define DSAF_PPE_INT_MSK_4_REG		  (0x130)
#define DSAF_PPE_INT_MSK_5_REG		  (0x134)
#define DSAF_ROCEE_INT_MSK_0_REG		(0x140)
#define DSAF_ROCEE_INT_MSK_1_REG		(0x144)
#define DSAF_ROCEE_INT_MSK_2_REG		(0x148)
#define DSAF_ROCEE_INT_MSK_3_REG		(0x14C)
#define DSAF_ROCEE_INT_MSK_4_REG		(0x150)
#define DSAF_ROCEE_INT_MSK_5_REG		(0x154)
#define DSAF_XGE_INT_SRC_0_REG		  (0x160)
#define DSAF_XGE_INT_SRC_1_REG		  (0x164)
#define DSAF_XGE_INT_SRC_2_REG		  (0x168)
#define DSAF_XGE_INT_SRC_3_REG		  (0x16C)
#define DSAF_XGE_INT_SRC_4_REG		  (0x170)
#define DSAF_XGE_INT_SRC_5_REG		  (0x174)
#define DSAF_PPE_INT_SRC_0_REG		  (0x180)
#define DSAF_PPE_INT_SRC_1_REG		  (0x184)
#define DSAF_PPE_INT_SRC_2_REG		  (0x188)
#define DSAF_PPE_INT_SRC_3_REG		  (0x18C)
#define DSAF_PPE_INT_SRC_4_REG		  (0x190)
#define DSAF_PPE_INT_SRC_5_REG		  (0x194)
#define DSAF_ROCEE_INT_SRC_0_REG		(0x1A0)
#define DSAF_ROCEE_INT_SRC_1_REG		(0x1A4)
#define DSAF_ROCEE_INT_SRC_2_REG		(0x1A8)
#define DSAF_ROCEE_INT_SRC_3_REG		(0x1AC)
#define DSAF_ROCEE_INT_SRC_4_REG		(0x1B0)
#define DSAF_ROCEE_INT_SRC_5_REG		(0x1B4)
#define DSAF_XGE_INT_STS_0_REG		  (0x1C0)
#define DSAF_XGE_INT_STS_1_REG		  (0x1C4)
#define DSAF_XGE_INT_STS_2_REG		  (0x1C8)
#define DSAF_XGE_INT_STS_3_REG		  (0x1CC)
#define DSAF_XGE_INT_STS_4_REG		  (0x1D0)
#define DSAF_XGE_INT_STS_5_REG		  (0x1D4)
#define DSAF_PPE_INT_STS_0_REG		  (0x1E0)
#define DSAF_PPE_INT_STS_1_REG		  (0x1E4)
#define DSAF_PPE_INT_STS_2_REG		  (0x1E8)
#define DSAF_PPE_INT_STS_3_REG		  (0x1EC)
#define DSAF_PPE_INT_STS_4_REG		  (0x1F0)
#define DSAF_PPE_INT_STS_5_REG		  (0x1F4)
#define DSAF_ROCEE_INT_STS_0_REG		(0x200)
#define DSAF_ROCEE_INT_STS_1_REG		(0x204)
#define DSAF_ROCEE_INT_STS_2_REG		(0x208)
#define DSAF_ROCEE_INT_STS_3_REG		(0x20C)
#define DSAF_ROCEE_INT_STS_4_REG		(0x210)
#define DSAF_ROCEE_INT_STS_5_REG		(0x214)
#define DSAF_PPE_QID_CFG_0_REG		  (0x300)
#define DSAF_PPE_QID_CFG_1_REG		  (0x304)
#define DSAF_PPE_QID_CFG_2_REG		  (0x308)
#define DSAF_PPE_QID_CFG_3_REG		  (0x30C)
#define DSAF_PPE_QID_CFG_4_REG		  (0x310)
#define DSAF_PPE_QID_CFG_5_REG		  (0x314)
#define DSAF_SW_PORT_TYPE_0_REG		 (0x320)
#define DSAF_SW_PORT_TYPE_1_REG		 (0x324)
#define DSAF_SW_PORT_TYPE_2_REG		 (0x328)
#define DSAF_SW_PORT_TYPE_3_REG		 (0x32C)
#define DSAF_SW_PORT_TYPE_4_REG		 (0x330)
#define DSAF_SW_PORT_TYPE_5_REG		 (0x334)
#define DSAF_SW_PORT_TYPE_6_REG		 (0x338)
#define DSAF_SW_PORT_TYPE_7_REG		 (0x33C)
#define DSAF_STP_PORT_TYPE_0_REG		(0x340)
#define DSAF_STP_PORT_TYPE_1_REG		(0x344)
#define DSAF_STP_PORT_TYPE_2_REG		(0x348)
#define DSAF_STP_PORT_TYPE_3_REG		(0x34C)
#define DSAF_STP_PORT_TYPE_4_REG		(0x350)
#define DSAF_STP_PORT_TYPE_5_REG		(0x354)
#define DSAF_MIX_DEF_QID_0_REG		  (0x360)
#define DSAF_MIX_DEF_QID_1_REG		  (0x364)
#define DSAF_MIX_DEF_QID_2_REG		  (0x368)
#define DSAF_MIX_DEF_QID_3_REG		  (0x36C)
#define DSAF_MIX_DEF_QID_4_REG		  (0x370)
#define DSAF_MIX_DEF_QID_5_REG		  (0x374)
#define DSAF_PORT_DEF_VLAN_0_REG		(0x380)
#define DSAF_PORT_DEF_VLAN_1_REG		(0x384)
#define DSAF_PORT_DEF_VLAN_2_REG		(0x388)
#define DSAF_PORT_DEF_VLAN_3_REG		(0x38C)
#define DSAF_PORT_DEF_VLAN_4_REG		(0x390)
#define DSAF_PORT_DEF_VLAN_5_REG		(0x394)
#define DSAF_PORT_DEF_VLAN_6_REG		(0x398)
#define DSAF_PORT_DEF_VLAN_7_REG		(0x39C)
#define DSAF_VM_DEF_VLAN_0_REG		  (0x400)
#define DSAF_VM_DEF_VLAN_1_REG		  (0x404)
#define DSAF_VM_DEF_VLAN_2_REG		  (0x408)
#define DSAF_VM_DEF_VLAN_3_REG		  (0x40C)
#define DSAF_VM_DEF_VLAN_4_REG		  (0x410)
#define DSAF_VM_DEF_VLAN_5_REG		  (0x414)
#define DSAF_VM_DEF_VLAN_6_REG		  (0x418)
#define DSAF_VM_DEF_VLAN_7_REG		  (0x41C)
#define DSAF_VM_DEF_VLAN_8_REG		  (0x420)
#define DSAF_VM_DEF_VLAN_9_REG		  (0x424)
#define DSAF_VM_DEF_VLAN_10_REG		 (0x428)
#define DSAF_VM_DEF_VLAN_11_REG		 (0x42C)
#define DSAF_VM_DEF_VLAN_12_REG		 (0x430)
#define DSAF_VM_DEF_VLAN_13_REG		 (0x434)
#define DSAF_VM_DEF_VLAN_14_REG		 (0x438)
#define DSAF_VM_DEF_VLAN_15_REG		 (0x43C)
#define DSAF_VM_DEF_VLAN_16_REG		 (0x440)
#define DSAF_VM_DEF_VLAN_17_REG		 (0x444)
#define DSAF_VM_DEF_VLAN_18_REG		 (0x448)
#define DSAF_VM_DEF_VLAN_19_REG		 (0x44C)
#define DSAF_VM_DEF_VLAN_20_REG		 (0x450)
#define DSAF_VM_DEF_VLAN_21_REG		 (0x454)
#define DSAF_VM_DEF_VLAN_22_REG		 (0x458)
#define DSAF_VM_DEF_VLAN_23_REG		 (0x45C)
#define DSAF_VM_DEF_VLAN_24_REG		 (0x460)
#define DSAF_VM_DEF_VLAN_25_REG		 (0x464)
#define DSAF_VM_DEF_VLAN_26_REG		 (0x468)
#define DSAF_VM_DEF_VLAN_27_REG		 (0x46C)
#define DSAF_VM_DEF_VLAN_28_REG		 (0x470)
#define DSAF_VM_DEF_VLAN_29_REG		 (0x474)
#define DSAF_VM_DEF_VLAN_30_REG		 (0x478)
#define DSAF_VM_DEF_VLAN_31_REG		 (0x47C)
#define DSAF_VM_DEF_VLAN_32_REG		 (0x480)
#define DSAF_VM_DEF_VLAN_33_REG		 (0x484)
#define DSAF_VM_DEF_VLAN_34_REG		 (0x488)
#define DSAF_VM_DEF_VLAN_35_REG		 (0x48C)
#define DSAF_VM_DEF_VLAN_36_REG		 (0x490)
#define DSAF_VM_DEF_VLAN_37_REG		 (0x494)
#define DSAF_VM_DEF_VLAN_38_REG		 (0x498)
#define DSAF_VM_DEF_VLAN_39_REG		 (0x49C)
#define DSAF_VM_DEF_VLAN_40_REG		 (0x4A0)
#define DSAF_VM_DEF_VLAN_41_REG		 (0x4A4)
#define DSAF_VM_DEF_VLAN_42_REG		 (0x4A8)
#define DSAF_VM_DEF_VLAN_43_REG		 (0x4AC)
#define DSAF_VM_DEF_VLAN_44_REG		 (0x4B0)
#define DSAF_VM_DEF_VLAN_45_REG		 (0x4B4)
#define DSAF_VM_DEF_VLAN_46_REG		 (0x4B8)
#define DSAF_VM_DEF_VLAN_47_REG		 (0x4BC)
#define DSAF_VM_DEF_VLAN_48_REG		 (0x4C0)
#define DSAF_VM_DEF_VLAN_49_REG		 (0x4C4)
#define DSAF_VM_DEF_VLAN_50_REG		 (0x4C8)
#define DSAF_VM_DEF_VLAN_51_REG		 (0x4CC)
#define DSAF_VM_DEF_VLAN_52_REG		 (0x4D0)
#define DSAF_VM_DEF_VLAN_53_REG		 (0x4D4)
#define DSAF_VM_DEF_VLAN_54_REG		 (0x4D8)
#define DSAF_VM_DEF_VLAN_55_REG		 (0x4DC)
#define DSAF_VM_DEF_VLAN_56_REG		 (0x4E0)
#define DSAF_VM_DEF_VLAN_57_REG		 (0x4E4)
#define DSAF_VM_DEF_VLAN_58_REG		 (0x4E8)
#define DSAF_VM_DEF_VLAN_59_REG		 (0x4EC)
#define DSAF_VM_DEF_VLAN_60_REG		 (0x4F0)
#define DSAF_VM_DEF_VLAN_61_REG		 (0x4F4)
#define DSAF_VM_DEF_VLAN_62_REG		 (0x4F8)
#define DSAF_VM_DEF_VLAN_63_REG		 (0x4FC)
#define DSAF_VM_DEF_VLAN_64_REG		 (0x500)
#define DSAF_VM_DEF_VLAN_65_REG		 (0x504)
#define DSAF_VM_DEF_VLAN_66_REG		 (0x508)
#define DSAF_VM_DEF_VLAN_67_REG		 (0x50C)
#define DSAF_VM_DEF_VLAN_68_REG		 (0x510)
#define DSAF_VM_DEF_VLAN_69_REG		 (0x514)
#define DSAF_VM_DEF_VLAN_70_REG		 (0x518)
#define DSAF_VM_DEF_VLAN_71_REG		 (0x51C)
#define DSAF_VM_DEF_VLAN_72_REG		 (0x520)
#define DSAF_VM_DEF_VLAN_73_REG		 (0x524)
#define DSAF_VM_DEF_VLAN_74_REG		 (0x528)
#define DSAF_VM_DEF_VLAN_75_REG		 (0x52C)
#define DSAF_VM_DEF_VLAN_76_REG		 (0x530)
#define DSAF_VM_DEF_VLAN_77_REG		 (0x534)
#define DSAF_VM_DEF_VLAN_78_REG		 (0x538)
#define DSAF_VM_DEF_VLAN_79_REG		 (0x53C)
#define DSAF_VM_DEF_VLAN_80_REG		 (0x540)
#define DSAF_VM_DEF_VLAN_81_REG		 (0x544)
#define DSAF_VM_DEF_VLAN_82_REG		 (0x548)
#define DSAF_VM_DEF_VLAN_83_REG		 (0x54C)
#define DSAF_VM_DEF_VLAN_84_REG		 (0x550)
#define DSAF_VM_DEF_VLAN_85_REG		 (0x554)
#define DSAF_VM_DEF_VLAN_86_REG		 (0x558)
#define DSAF_VM_DEF_VLAN_87_REG		 (0x55C)
#define DSAF_VM_DEF_VLAN_88_REG		 (0x560)
#define DSAF_VM_DEF_VLAN_89_REG		 (0x564)
#define DSAF_VM_DEF_VLAN_90_REG		 (0x568)
#define DSAF_VM_DEF_VLAN_91_REG		 (0x56C)
#define DSAF_VM_DEF_VLAN_92_REG		 (0x570)
#define DSAF_VM_DEF_VLAN_93_REG		 (0x574)
#define DSAF_VM_DEF_VLAN_94_REG		 (0x578)
#define DSAF_VM_DEF_VLAN_95_REG		 (0x57C)
#define DSAF_VM_DEF_VLAN_96_REG		 (0x580)
#define DSAF_VM_DEF_VLAN_97_REG		 (0x584)
#define DSAF_VM_DEF_VLAN_98_REG		 (0x588)
#define DSAF_VM_DEF_VLAN_99_REG		 (0x58C)
#define DSAF_VM_DEF_VLAN_100_REG		(0x590)
#define DSAF_VM_DEF_VLAN_101_REG		(0x594)
#define DSAF_VM_DEF_VLAN_102_REG		(0x598)
#define DSAF_VM_DEF_VLAN_103_REG		(0x59C)
#define DSAF_VM_DEF_VLAN_104_REG		(0x5A0)
#define DSAF_VM_DEF_VLAN_105_REG		(0x5A4)
#define DSAF_VM_DEF_VLAN_106_REG		(0x5A8)
#define DSAF_VM_DEF_VLAN_107_REG		(0x5AC)
#define DSAF_VM_DEF_VLAN_108_REG		(0x5B0)
#define DSAF_VM_DEF_VLAN_109_REG		(0x5B4)
#define DSAF_VM_DEF_VLAN_110_REG		(0x5B8)
#define DSAF_VM_DEF_VLAN_111_REG		(0x5BC)
#define DSAF_VM_DEF_VLAN_112_REG		(0x5C0)
#define DSAF_VM_DEF_VLAN_113_REG		(0x5C4)
#define DSAF_VM_DEF_VLAN_114_REG		(0x5C8)
#define DSAF_VM_DEF_VLAN_115_REG		(0x5CC)
#define DSAF_VM_DEF_VLAN_116_REG		(0x5D0)
#define DSAF_VM_DEF_VLAN_117_REG		(0x5D4)
#define DSAF_VM_DEF_VLAN_118_REG		(0x5D8)
#define DSAF_VM_DEF_VLAN_119_REG		(0x5DC)
#define DSAF_VM_DEF_VLAN_120_REG		(0x5E0)
#define DSAF_VM_DEF_VLAN_121_REG		(0x5E4)
#define DSAF_VM_DEF_VLAN_122_REG		(0x5E8)
#define DSAF_VM_DEF_VLAN_123_REG		(0x5EC)
#define DSAF_VM_DEF_VLAN_124_REG		(0x5F0)
#define DSAF_VM_DEF_VLAN_125_REG		(0x5F4)
#define DSAF_VM_DEF_VLAN_126_REG		(0x5F8)
#define DSAF_VM_DEF_VLAN_127_REG		(0x5FC)
#define DSAF_VM_DEF_VLAN_128_REG		(0x600)
#define DSAF_INODE_CUT_THROUGH_CFG_0_REG		  (0x1000)
#define DSAF_INODE_ECC_INVERT_EN_0_REG			(0x1008)
#define DSAF_INODE_ECC_INVERT_EN_1_REG			(0x1088)
#define DSAF_INODE_ECC_INVERT_EN_2_REG			(0x1108)
#define DSAF_INODE_ECC_INVERT_EN_3_REG			(0x1188)
#define DSAF_INODE_ECC_INVERT_EN_4_REG			(0x1208)
#define DSAF_INODE_ECC_INVERT_EN_5_REG			(0x1288)
#define DSAF_INODE_ECC_ERR_ADDR_0_REG		(0x100C)
#define DSAF_INODE_ECC_ERR_ADDR_1_REG		(0x108C)
#define DSAF_INODE_ECC_ERR_ADDR_2_REG	(0x110C)
#define DSAF_INODE_ECC_ERR_ADDR_3_REG	(0x118C)
#define DSAF_INODE_ECC_ERR_ADDR_4_REG	(0x120C)
#define DSAF_INODE_ECC_ERR_ADDR_5_REG	(0x128C)
#define DSAF_INODE_IN_PORT_NUM_0_REG		 (0x1018)
#define DSAF_INODE_IN_PORT_NUM_1_REG		 (0x1098)
#define DSAF_INODE_IN_PORT_NUM_2_REG		 (0x1118)
#define DSAF_INODE_IN_PORT_NUM_3_REG		 (0x1198)
#define DSAF_INODE_IN_PORT_NUM_4_REG		 (0x1218)
#define DSAF_INODE_IN_PORT_NUM_5_REG		 (0x1298)
#define DSAF_INODE_IN_PORT_NUM_6_REG		 (0x1318)
#define DSAF_INODE_IN_PORT_NUM_7_REG		 (0x1398)
#define DSAF_INODE_IN_PORT_NUM_8_REG		 (0x1418)
#define DSAF_INODE_IN_PORT_NUM_9_REG		 (0x1498)
#define DSAF_INODE_IN_PORT_NUM_10_REG	(0x1518)
#define DSAF_INODE_IN_PORT_NUM_11_REG	(0x1598)
#define DSAF_INODE_IN_PORT_NUM_12_REG	(0x1618)
#define DSAF_INODE_IN_PORT_NUM_13_REG	(0x1698)
#define DSAF_INODE_IN_PORT_NUM_14_REG	(0x1718)
#define DSAF_INODE_IN_PORT_NUM_15_REG	(0x1798)
#define DSAF_INODE_IN_PORT_NUM_16_REG	(0x1818)
#define DSAF_INODE_IN_PORT_NUM_17_REG	(0x1898)
#define DSAF_INODE_PRI_TC_CFG_0_REG		  (0x101C)
#define DSAF_INODE_PRI_TC_CFG_1_REG		  (0x109C)
#define DSAF_INODE_PRI_TC_CFG_2_REG		  (0x111C)
#define DSAF_INODE_PRI_TC_CFG_3_REG		  (0x119C)
#define DSAF_INODE_PRI_TC_CFG_4_REG		  (0x121C)
#define DSAF_INODE_PRI_TC_CFG_5_REG		  (0x129C)
#define DSAF_INODE_PRI_TC_CFG_6_REG		  (0x131C)
#define DSAF_INODE_PRI_TC_CFG_7_REG		  (0x139C)
#define DSAF_INODE_PRI_TC_CFG_8_REG		  (0x141C)
#define DSAF_INODE_PRI_TC_CFG_9_REG		  (0x149C)
#define DSAF_INODE_PRI_TC_CFG_10_REG		 (0x151C)
#define DSAF_INODE_PRI_TC_CFG_11_REG		 (0x159C)
#define DSAF_INODE_PRI_TC_CFG_12_REG		 (0x161C)
#define DSAF_INODE_PRI_TC_CFG_13_REG		 (0x169C)
#define DSAF_INODE_PRI_TC_CFG_14_REG		 (0x171C)
#define DSAF_INODE_PRI_TC_CFG_15_REG		 (0x179C)
#define DSAF_INODE_PRI_TC_CFG_16_REG		 (0x181C)
#define DSAF_INODE_PRI_TC_CFG_17_REG		 (0x189C)
#define DSAF_INODE_BP_STATUS_0_REG	(0x1020)
#define DSAF_INODE_BP_STATUS_1_REG	(0x10A0)
#define DSAF_INODE_BP_STATUS_2_REG	(0x1120)
#define DSAF_INODE_BP_STATUS_3_REG	(0x11A0)
#define DSAF_INODE_BP_STATUS_4_REG	(0x1220)
#define DSAF_INODE_BP_STATUS_5_REG	(0x12A0)
#define DSAF_INODE_BP_STATUS_6_REG	(0x1320)
#define DSAF_INODE_BP_STATUS_7_REG	(0x13A0)
#define DSAF_INODE_BP_STATUS_8_REG	(0x1420)
#define DSAF_INODE_BP_STATUS_9_REG	(0x14A0)
#define DSAF_INODE_BP_STATUS_10_REG	(0x1520)
#define DSAF_INODE_BP_STATUS_11_REG	(0x15A0)
#define DSAF_INODE_BP_STATUS_12_REG	(0x1620)
#define DSAF_INODE_BP_STATUS_13_REG	(0x16A0)
#define DSAF_INODE_BP_STATUS_14_REG	(0x1720)
#define DSAF_INODE_BP_STATUS_15_REG	(0x17A0)
#define DSAF_INODE_BP_STATUS_16_REG	(0x1820)
#define DSAF_INODE_BP_STATUS_17_REG	(0x18A0)
#define DSAF_INODE_PAD_DISCARD_NUM_0_REG	(0x1028)
#define DSAF_INODE_PAD_DISCARD_NUM_1_REG	(0x10A8)
#define DSAF_INODE_PAD_DISCARD_NUM_2_REG	(0x1128)
#define DSAF_INODE_PAD_DISCARD_NUM_3_REG	(0x11A8)
#define DSAF_INODE_PAD_DISCARD_NUM_4_REG	(0x1228)
#define DSAF_INODE_PAD_DISCARD_NUM_5_REG	(0x12A8)
#define DSAF_INODE_PAD_DISCARD_NUM_6_REG	(0x1328)
#define DSAF_INODE_PAD_DISCARD_NUM_7_REG	(0x13A8)
#define DSAF_INODE_PAD_DISCARD_NUM_8_REG	(0x1428)
#define DSAF_INODE_PAD_DISCARD_NUM_9_REG	(0x14A8)
#define DSAF_INODE_PAD_DISCARD_NUM_10_REG	(0x1528)
#define DSAF_INODE_PAD_DISCARD_NUM_11_REG	(0x15A8)
#define DSAF_INODE_PAD_DISCARD_NUM_12_REG		 (0x1628)
#define DSAF_INODE_PAD_DISCARD_NUM_13_REG		 (0x16A8)
#define DSAF_INODE_PAD_DISCARD_NUM_14_REG		 (0x1728)
#define DSAF_INODE_PAD_DISCARD_NUM_15_REG		 (0x17A8)
#define DSAF_INODE_PAD_DISCARD_NUM_16_REG		 (0x1828)
#define DSAF_INODE_PAD_DISCARD_NUM_17_REG		 (0x18A8)
#define DSAF_INODE_FINAL_IN_MAN_NUM_0_REG		 (0x102C)
#define DSAF_INODE_FINAL_IN_MAN_NUM_1_REG		 (0x10AC)
#define DSAF_INODE_FINAL_IN_MAN_NUM_2_REG		 (0x112C)
#define DSAF_INODE_FINAL_IN_MAN_NUM_3_REG		 (0x11AC)
#define DSAF_INODE_FINAL_IN_MAN_NUM_4_REG		 (0x122C)
#define DSAF_INODE_FINAL_IN_MAN_NUM_5_REG		 (0x12AC)
#define DSAF_INODE_FINAL_IN_MAN_NUM_6_REG		 (0x132C)
#define DSAF_INODE_FINAL_IN_MAN_NUM_7_REG		 (0x13AC)
#define DSAF_INODE_FINAL_IN_MAN_NUM_8_REG		 (0x142C)
#define DSAF_INODE_FINAL_IN_MAN_NUM_9_REG		 (0x14AC)
#define DSAF_INODE_FINAL_IN_MAN_NUM_10_REG	(0x152C)
#define DSAF_INODE_FINAL_IN_MAN_NUM_11_REG	(0x15AC)
#define DSAF_INODE_FINAL_IN_MAN_NUM_12_REG	(0x162C)
#define DSAF_INODE_FINAL_IN_MAN_NUM_13_REG	(0x16AC)
#define DSAF_INODE_FINAL_IN_MAN_NUM_14_REG	(0x172C)
#define DSAF_INODE_FINAL_IN_MAN_NUM_15_REG	(0x17AC)
#define DSAF_INODE_FINAL_IN_MAN_NUM_16_REG	(0x182C)
#define DSAF_INODE_FINAL_IN_MAN_NUM_17_REG	(0x18AC)
#define DSAF_INODE_FINAL_IN_PKT_NUM_0_REG		 (0x1030)
#define DSAF_INODE_FINAL_IN_PKT_NUM_1_REG		 (0x10B0)
#define DSAF_INODE_FINAL_IN_PKT_NUM_2_REG		 (0x1130)
#define DSAF_INODE_FINAL_IN_PKT_NUM_3_REG		 (0x11B0)
#define DSAF_INODE_FINAL_IN_PKT_NUM_4_REG		 (0x1230)
#define DSAF_INODE_FINAL_IN_PKT_NUM_5_REG		 (0x12B0)
#define DSAF_INODE_FINAL_IN_PKT_NUM_6_REG		 (0x1330)
#define DSAF_INODE_FINAL_IN_PKT_NUM_7_REG		 (0x13B0)
#define DSAF_INODE_FINAL_IN_PKT_NUM_8_REG		 (0x1430)
#define DSAF_INODE_FINAL_IN_PKT_NUM_9_REG		 (0x14B0)
#define DSAF_INODE_FINAL_IN_PKT_NUM_10_REG	(0x1530)
#define DSAF_INODE_FINAL_IN_PKT_NUM_11_REG	(0x15B0)
#define DSAF_INODE_FINAL_IN_PKT_NUM_12_REG	(0x1630)
#define DSAF_INODE_FINAL_IN_PKT_NUM_13_REG	(0x16B0)
#define DSAF_INODE_FINAL_IN_PKT_NUM_14_REG	(0x1730)
#define DSAF_INODE_FINAL_IN_PKT_NUM_15_REG	(0x17B0)
#define DSAF_INODE_FINAL_IN_PKT_NUM_16_REG	(0x1830)
#define DSAF_INODE_FINAL_IN_PKT_NUM_17_REG	(0x18B0)
#define DSAF_INODE_SBM_PID_NUM_0_REG		 (0x1038)
#define DSAF_INODE_SBM_PID_NUM_1_REG		 (0x10B8)
#define DSAF_INODE_SBM_PID_NUM_2_REG		 (0x1138)
#define DSAF_INODE_SBM_PID_NUM_3_REG		 (0x11B8)
#define DSAF_INODE_SBM_PID_NUM_4_REG		 (0x1238)
#define DSAF_INODE_SBM_PID_NUM_5_REG		 (0x12B8)
#define DSAF_INODE_SBM_PID_NUM_6_REG		 (0x1338)
#define DSAF_INODE_SBM_PID_NUM_7_REG		 (0x13B8)
#define DSAF_INODE_SBM_PID_NUM_8_REG		 (0x1438)
#define DSAF_INODE_SBM_PID_NUM_9_REG		 (0x14B8)
#define DSAF_INODE_SBM_PID_NUM_10_REG	(0x1538)
#define DSAF_INODE_SBM_PID_NUM_11_REG	(0x15B8)
#define DSAF_INODE_SBM_PID_NUM_12_REG	(0x1638)
#define DSAF_INODE_SBM_PID_NUM_13_REG	(0x16B8)
#define DSAF_INODE_SBM_PID_NUM_14_REG	(0x1738)
#define DSAF_INODE_SBM_PID_NUM_15_REG	(0x17B8)
#define DSAF_INODE_SBM_PID_NUM_16_REG	(0x1838)
#define DSAF_INODE_SBM_PID_NUM_17_REG	(0x18B8)
#define DSAF_INODE_FINAL_IN_PAUSE_NUM_0_REG	   (0x103C)
#define DSAF_INODE_FINAL_IN_PAUSE_NUM_1_REG	   (0x10BC)
#define DSAF_INODE_FINAL_IN_PAUSE_NUM_2_REG	   (0x113C)
#define DSAF_INODE_FINAL_IN_PAUSE_NUM_3_REG	   (0x11BC)
#define DSAF_INODE_FINAL_IN_PAUSE_NUM_4_REG	   (0x123C)
#define DSAF_INODE_FINAL_IN_PAUSE_NUM_5_REG	   (0x12BC)
#define DSAF_INODE_FINAL_IN_PAUSE_NUM_6_REG	   (0x133C)
#define DSAF_INODE_FINAL_IN_PAUSE_NUM_7_REG	   (0x13BC)
#define DSAF_INODE_FINAL_IN_PAUSE_NUM_8_REG	   (0x143C)
#define DSAF_INODE_FINAL_IN_PAUSE_NUM_9_REG	   (0x14BC)
#define DSAF_INODE_FINAL_IN_PAUSE_NUM_10_REG	  (0x153C)
#define DSAF_INODE_FINAL_IN_PAUSE_NUM_11_REG	  (0x15BC)
#define DSAF_INODE_FINAL_IN_PAUSE_NUM_12_REG	  (0x163C)
#define DSAF_INODE_FINAL_IN_PAUSE_NUM_13_REG	  (0x16BC)
#define DSAF_INODE_FINAL_IN_PAUSE_NUM_14_REG	  (0x173C)
#define DSAF_INODE_FINAL_IN_PAUSE_NUM_15_REG	  (0x17BC)
#define DSAF_INODE_FINAL_IN_PAUSE_NUM_16_REG	  (0x183C)
#define DSAF_INODE_FINAL_IN_PAUSE_NUM_17_REG	  (0x18BC)
#define DSAF_INODE_SBM_RELS_NUM_0_REG	(0x104C)
#define DSAF_INODE_SBM_RELS_NUM_1_REG	(0x10CC)
#define DSAF_INODE_SBM_RELS_NUM_2_REG	(0x114C)
#define DSAF_INODE_SBM_RELS_NUM_3_REG	(0x11CC)
#define DSAF_INODE_SBM_RELS_NUM_4_REG	(0x124C)
#define DSAF_INODE_SBM_RELS_NUM_5_REG	(0x12CC)
#define DSAF_INODE_SBM_RELS_NUM_6_REG	(0x134C)
#define DSAF_INODE_SBM_RELS_NUM_7_REG	(0x13CC)
#define DSAF_INODE_SBM_RELS_NUM_8_REG	(0x144C)
#define DSAF_INODE_SBM_RELS_NUM_9_REG	(0x14CC)
#define DSAF_INODE_SBM_RELS_NUM_10_REG		(0x154C)
#define DSAF_INODE_SBM_RELS_NUM_11_REG		(0x15CC)
#define DSAF_INODE_SBM_RELS_NUM_12_REG		(0x164C)
#define DSAF_INODE_SBM_RELS_NUM_13_REG		(0x16CC)
#define DSAF_INODE_SBM_RELS_NUM_14_REG		(0x174C)
#define DSAF_INODE_SBM_RELS_NUM_15_REG		(0x17CC)
#define DSAF_INODE_SBM_RELS_NUM_16_REG		(0x184C)
#define DSAF_INODE_SBM_RELS_NUM_17_REG		(0x18CC)
#define DSAF_INODE_SBM_DROP_NUM_0_REG	(0x1050)
#define DSAF_INODE_SBM_DROP_NUM_1_REG	(0x10D0)
#define DSAF_INODE_SBM_DROP_NUM_2_REG	(0x1150)
#define DSAF_INODE_SBM_DROP_NUM_3_REG	(0x11D0)
#define DSAF_INODE_SBM_DROP_NUM_4_REG	(0x1250)
#define DSAF_INODE_SBM_DROP_NUM_5_REG	(0x12D0)
#define DSAF_INODE_SBM_DROP_NUM_6_REG	(0x1350)
#define DSAF_INODE_SBM_DROP_NUM_7_REG	(0x13D0)
#define DSAF_INODE_SBM_DROP_NUM_8_REG	(0x1450)
#define DSAF_INODE_SBM_DROP_NUM_9_REG	(0x14D0)
#define DSAF_INODE_SBM_DROP_NUM_10_REG		(0x1550)
#define DSAF_INODE_SBM_DROP_NUM_11_REG		(0x15D0)
#define DSAF_INODE_SBM_DROP_NUM_12_REG		(0x1650)
#define DSAF_INODE_SBM_DROP_NUM_13_REG		(0x16D0)
#define DSAF_INODE_SBM_DROP_NUM_14_REG		(0x1750)
#define DSAF_INODE_SBM_DROP_NUM_15_REG		(0x17D0)
#define DSAF_INODE_SBM_DROP_NUM_16_REG		(0x1850)
#define DSAF_INODE_SBM_DROP_NUM_17_REG		(0x18D0)
#define DSAF_INODE_CRC_FALSE_NUM_0_REG		(0x1054)
#define DSAF_INODE_CRC_FALSE_NUM_1_REG		(0x10D4)
#define DSAF_INODE_CRC_FALSE_NUM_2_REG		(0x1154)
#define DSAF_INODE_CRC_FALSE_NUM_3_REG		(0x11D4)
#define DSAF_INODE_CRC_FALSE_NUM_4_REG		(0x1254)
#define DSAF_INODE_CRC_FALSE_NUM_5_REG		(0x12D4)
#define DSAF_INODE_CRC_FALSE_NUM_6_REG		(0x1354)
#define DSAF_INODE_CRC_FALSE_NUM_7_REG		(0x13D4)
#define DSAF_INODE_CRC_FALSE_NUM_8_REG		(0x1454)
#define DSAF_INODE_CRC_FALSE_NUM_9_REG		(0x14D4)
#define DSAF_INODE_CRC_FALSE_NUM_10_REG		   (0x1554)
#define DSAF_INODE_CRC_FALSE_NUM_11_REG		   (0x15D4)
#define DSAF_INODE_CRC_FALSE_NUM_12_REG		   (0x1654)
#define DSAF_INODE_CRC_FALSE_NUM_13_REG		   (0x16D4)
#define DSAF_INODE_CRC_FALSE_NUM_14_REG		   (0x1754)
#define DSAF_INODE_CRC_FALSE_NUM_15_REG		   (0x17D4)
#define DSAF_INODE_CRC_FALSE_NUM_16_REG		   (0x1854)
#define DSAF_INODE_CRC_FALSE_NUM_17_REG		   (0x18D4)
#define DSAF_INODE_BP_DISCARD_NUM_0_REG		   (0x1058)
#define DSAF_INODE_BP_DISCARD_NUM_1_REG		   (0x10D8)
#define DSAF_INODE_BP_DISCARD_NUM_2_REG		   (0x1158)
#define DSAF_INODE_BP_DISCARD_NUM_3_REG		   (0x11D8)
#define DSAF_INODE_BP_DISCARD_NUM_4_REG		   (0x1258)
#define DSAF_INODE_BP_DISCARD_NUM_5_REG		   (0x12D8)
#define DSAF_INODE_BP_DISCARD_NUM_6_REG		   (0x1358)
#define DSAF_INODE_BP_DISCARD_NUM_7_REG		   (0x13D8)
#define DSAF_INODE_BP_DISCARD_NUM_8_REG		   (0x1458)
#define DSAF_INODE_BP_DISCARD_NUM_9_REG		   (0x14D8)
#define DSAF_INODE_BP_DISCARD_NUM_10_REG		  (0x1558)
#define DSAF_INODE_BP_DISCARD_NUM_11_REG		  (0x15D8)
#define DSAF_INODE_BP_DISCARD_NUM_12_REG		  (0x1658)
#define DSAF_INODE_BP_DISCARD_NUM_13_REG		  (0x16D8)
#define DSAF_INODE_BP_DISCARD_NUM_14_REG		  (0x1758)
#define DSAF_INODE_BP_DISCARD_NUM_15_REG		  (0x17D8)
#define DSAF_INODE_BP_DISCARD_NUM_16_REG		  (0x1858)
#define DSAF_INODE_BP_DISCARD_NUM_17_REG		  (0x18D8)
#define DSAF_INODE_RSLT_DISCARD_NUM_0_REG		 (0x105C)
#define DSAF_INODE_RSLT_DISCARD_NUM_1_REG		 (0x10DC)
#define DSAF_INODE_RSLT_DISCARD_NUM_2_REG		 (0x115C)
#define DSAF_INODE_RSLT_DISCARD_NUM_3_REG		 (0x11DC)
#define DSAF_INODE_RSLT_DISCARD_NUM_4_REG		 (0x125C)
#define DSAF_INODE_RSLT_DISCARD_NUM_5_REG		 (0x12DC)
#define DSAF_INODE_RSLT_DISCARD_NUM_6_REG		 (0x135C)
#define DSAF_INODE_RSLT_DISCARD_NUM_7_REG		 (0x13DC)
#define DSAF_INODE_RSLT_DISCARD_NUM_8_REG		 (0x145C)
#define DSAF_INODE_RSLT_DISCARD_NUM_9_REG		 (0x14DC)
#define DSAF_INODE_RSLT_DISCARD_NUM_10_REG	(0x155C)
#define DSAF_INODE_RSLT_DISCARD_NUM_11_REG	(0x15DC)
#define DSAF_INODE_RSLT_DISCARD_NUM_12_REG	(0x165C)
#define DSAF_INODE_RSLT_DISCARD_NUM_13_REG	(0x16DC)
#define DSAF_INODE_RSLT_DISCARD_NUM_14_REG	(0x175C)
#define DSAF_INODE_RSLT_DISCARD_NUM_15_REG	(0x17DC)
#define DSAF_INODE_RSLT_DISCARD_NUM_16_REG	(0x185C)
#define DSAF_INODE_RSLT_DISCARD_NUM_17_REG	(0x18DC)
#define DSAF_INODE_LOCAL_ADDR_FALSE_NUM_0_REG	 (0x1060)
#define DSAF_INODE_LOCAL_ADDR_FALSE_NUM_1_REG	 (0x10E0)
#define DSAF_INODE_LOCAL_ADDR_FALSE_NUM_2_REG	 (0x1160)
#define DSAF_INODE_LOCAL_ADDR_FALSE_NUM_3_REG	 (0x11E0)
#define DSAF_INODE_LOCAL_ADDR_FALSE_NUM_4_REG	 (0x1260)
#define DSAF_INODE_LOCAL_ADDR_FALSE_NUM_5_REG	 (0x12E0)
#define DSAF_INODE_LOCAL_ADDR_FALSE_NUM_6_REG	 (0x1360)
#define DSAF_INODE_LOCAL_ADDR_FALSE_NUM_7_REG	 (0x13E0)
#define DSAF_INODE_LOCAL_ADDR_FALSE_NUM_8_REG	 (0x1460)
#define DSAF_INODE_LOCAL_ADDR_FALSE_NUM_9_REG	 (0x14E0)
#define DSAF_INODE_LOCAL_ADDR_FALSE_NUM_10_REG	(0x1560)
#define DSAF_INODE_LOCAL_ADDR_FALSE_NUM_11_REG	(0x15E0)
#define DSAF_INODE_LOCAL_ADDR_FALSE_NUM_12_REG	(0x1660)
#define DSAF_INODE_LOCAL_ADDR_FALSE_NUM_13_REG	(0x16E0)
#define DSAF_INODE_LOCAL_ADDR_FALSE_NUM_14_REG	(0x1760)
#define DSAF_INODE_LOCAL_ADDR_FALSE_NUM_15_REG	(0x17E0)
#define DSAF_INODE_LOCAL_ADDR_FALSE_NUM_16_REG	(0x1860)
#define DSAF_INODE_LOCAL_ADDR_FALSE_NUM_17_REG	(0x18E0)
#define DSAF_INODE_VOQ_OVER_NUM_0_REG	(0x1068)
#define DSAF_INODE_VOQ_OVER_NUM_1_REG	(0x10E8)
#define DSAF_INODE_VOQ_OVER_NUM_2_REG	(0x1168)
#define DSAF_INODE_VOQ_OVER_NUM_3_REG	(0x11E8)
#define DSAF_INODE_VOQ_OVER_NUM_4_REG	(0x1268)
#define DSAF_INODE_VOQ_OVER_NUM_5_REG	(0x12E8)
#define DSAF_INODE_VOQ_OVER_NUM_6_REG	(0x1368)
#define DSAF_INODE_VOQ_OVER_NUM_7_REG	(0x13E8)
#define DSAF_INODE_VOQ_OVER_NUM_8_REG	(0x1468)
#define DSAF_INODE_VOQ_OVER_NUM_9_REG	(0x14E8)
#define DSAF_INODE_VOQ_OVER_NUM_10_REG		(0x1568)
#define DSAF_INODE_VOQ_OVER_NUM_11_REG		(0x15E8)
#define DSAF_INODE_VOQ_OVER_NUM_12_REG		(0x1668)
#define DSAF_INODE_VOQ_OVER_NUM_13_REG		(0x16E8)
#define DSAF_INODE_VOQ_OVER_NUM_14_REG		(0x1768)
#define DSAF_INODE_VOQ_OVER_NUM_15_REG		(0x17E8)
#define DSAF_INODE_VOQ_OVER_NUM_16_REG		(0x1868)
#define DSAF_INODE_VOQ_OVER_NUM_17_REG		(0x18E8)
#define DSAF_INODE_BD_SAVE_STATUS_0_REG		   (0x1900)
#define DSAF_INODE_BD_SAVE_STATUS_1_REG		   (0x1904)
#define DSAF_INODE_BD_SAVE_STATUS_2_REG		   (0x1908)
#define DSAF_INODE_BD_SAVE_STATUS_3_REG		   (0x190C)
#define DSAF_INODE_BD_SAVE_STATUS_4_REG		   (0x1910)
#define DSAF_INODE_BD_SAVE_STATUS_5_REG		   (0x1914)
#define DSAF_INODE_BD_SAVE_STATUS_6_REG		   (0x1918)
#define DSAF_INODE_BD_SAVE_STATUS_7_REG		   (0x191C)
#define DSAF_INODE_BD_SAVE_STATUS_8_REG		   (0x1920)
#define DSAF_INODE_BD_SAVE_STATUS_9_REG		   (0x1924)
#define DSAF_INODE_BD_SAVE_STATUS_10_REG		  (0x1928)
#define DSAF_INODE_BD_SAVE_STATUS_11_REG		  (0x192C)
#define DSAF_INODE_BD_SAVE_STATUS_12_REG		  (0x1930)
#define DSAF_INODE_BD_SAVE_STATUS_13_REG		  (0x1934)
#define DSAF_INODE_BD_SAVE_STATUS_14_REG		  (0x1938)
#define DSAF_INODE_BD_SAVE_STATUS_15_REG		  (0x193C)
#define DSAF_INODE_BD_SAVE_STATUS_16_REG		  (0x1940)
#define DSAF_INODE_BD_SAVE_STATUS_17_REG		  (0x1944)
#define DSAF_INODE_BD_ORDER_STATUS_0_REG		  (0x1950)
#define DSAF_INODE_BD_ORDER_STATUS_1_REG		  (0x1954)
#define DSAF_INODE_BD_ORDER_STATUS_2_REG		  (0x1958)
#define DSAF_INODE_BD_ORDER_STATUS_3_REG		  (0x195C)
#define DSAF_INODE_BD_ORDER_STATUS_4_REG		  (0x1960)
#define DSAF_INODE_BD_ORDER_STATUS_5_REG		  (0x1964)
#define DSAF_INODE_BD_ORDER_STATUS_6_REG		  (0x1968)
#define DSAF_INODE_BD_ORDER_STATUS_7_REG		  (0x196C)
#define DSAF_INODE_BD_ORDER_STATUS_8_REG		  (0x1970)
#define DSAF_INODE_BD_ORDER_STATUS_9_REG		  (0x1974)
#define DSAF_INODE_BD_ORDER_STATUS_10_REG		 (0x1978)
#define DSAF_INODE_BD_ORDER_STATUS_11_REG		 (0x197C)
#define DSAF_INODE_BD_ORDER_STATUS_12_REG		 (0x1980)
#define DSAF_INODE_BD_ORDER_STATUS_13_REG		 (0x1984)
#define DSAF_INODE_BD_ORDER_STATUS_14_REG		 (0x1988)
#define DSAF_INODE_BD_ORDER_STATUS_15_REG		 (0x198C)
#define DSAF_INODE_BD_ORDER_STATUS_16_REG		 (0x1990)
#define DSAF_INODE_BD_ORDER_STATUS_17_REG		 (0x1994)
#define DSAF_INODE_SW_VLAN_TAG_DISC_0_REG		 (0x1A00)
#define DSAF_INODE_SW_VLAN_TAG_DISC_1_REG		 (0x1A04)
#define DSAF_INODE_SW_VLAN_TAG_DISC_2_REG		 (0x1A08)
#define DSAF_INODE_SW_VLAN_TAG_DISC_3_REG		 (0x1A0C)
#define DSAF_INODE_SW_VLAN_TAG_DISC_4_REG		 (0x1A10)
#define DSAF_INODE_SW_VLAN_TAG_DISC_5_REG		 (0x1A14)
#define DSAF_INODE_SW_VLAN_TAG_DISC_6_REG		 (0x1A18)
#define DSAF_INODE_SW_VLAN_TAG_DISC_7_REG		 (0x1A1C)
#define DSAF_INODE_SW_VLAN_TAG_DISC_8_REG		 (0x1A20)
#define DSAF_INODE_SW_VLAN_TAG_DISC_9_REG		 (0x1A24)
#define DSAF_INODE_SW_VLAN_TAG_DISC_10_REG	(0x1A28)
#define DSAF_INODE_SW_VLAN_TAG_DISC_11_REG	(0x1A2C)
#define DSAF_INODE_SW_VLAN_TAG_DISC_12_REG	(0x1A30)
#define DSAF_INODE_SW_VLAN_TAG_DISC_13_REG	(0x1A34)
#define DSAF_INODE_SW_VLAN_TAG_DISC_14_REG	(0x1A38)
#define DSAF_INODE_SW_VLAN_TAG_DISC_15_REG	(0x1A3C)
#define DSAF_INODE_SW_VLAN_TAG_DISC_16_REG	(0x1A40)
#define DSAF_INODE_SW_VLAN_TAG_DISC_17_REG	(0x1A44)
#define DSAF_INODE_IN_DATA_STP_DISC_0_REG		 (0x1A50)
#define DSAF_INODE_IN_DATA_STP_DISC_1_REG		 (0x1A54)
#define DSAF_INODE_IN_DATA_STP_DISC_2_REG		 (0x1A58)
#define DSAF_INODE_IN_DATA_STP_DISC_3_REG		 (0x1A5C)
#define DSAF_INODE_IN_DATA_STP_DISC_4_REG		 (0x1A60)
#define DSAF_INODE_IN_DATA_STP_DISC_5_REG		 (0x1A64)
#define DSAF_INODE_IN_DATA_STP_DISC_6_REG		 (0x1A68)
#define DSAF_INODE_IN_DATA_STP_DISC_7_REG		 (0x1A6C)
#define DSAF_INODE_IN_DATA_STP_DISC_8_REG		 (0x1A70)
#define DSAF_INODE_IN_DATA_STP_DISC_9_REG		 (0x1A74)
#define DSAF_INODE_IN_DATA_STP_DISC_10_REG	(0x1A78)
#define DSAF_INODE_IN_DATA_STP_DISC_11_REG	(0x1A7C)
#define DSAF_INODE_IN_DATA_STP_DISC_12_REG	(0x1A80)
#define DSAF_INODE_IN_DATA_STP_DISC_13_REG	(0x1A84)
#define DSAF_INODE_IN_DATA_STP_DISC_14_REG	(0x1A88)
#define DSAF_INODE_IN_DATA_STP_DISC_15_REG	(0x1A8C)
#define DSAF_INODE_IN_DATA_STP_DISC_16_REG	(0x1A90)
#define DSAF_INODE_IN_DATA_STP_DISC_17_REG	(0x1A94)
#define DSAF_INODE_GE_FC_EN_0_REG		(0x1B00)
#define DSAF_INODE_GE_FC_EN_1_REG		(0x1B04)
#define DSAF_INODE_GE_FC_EN_2_REG		(0x1B08)
#define DSAF_INODE_GE_FC_EN_3_REG		(0x1B0C)
#define DSAF_INODE_GE_FC_EN_4_REG		(0x1B10)
#define DSAF_INODE_GE_FC_EN_5_REG		(0x1B14)
#define DSAF_INODE_VC0_IN_PKT_NUM_0_REG		   (0x1B50)
#define DSAF_INODE_VC0_IN_PKT_NUM_1_REG		   (0x1B54)
#define DSAF_INODE_VC0_IN_PKT_NUM_2_REG		   (0x1B58)
#define DSAF_INODE_VC0_IN_PKT_NUM_3_REG		   (0x1B5C)
#define DSAF_INODE_VC0_IN_PKT_NUM_4_REG		   (0x1B60)
#define DSAF_INODE_VC0_IN_PKT_NUM_5_REG		   (0x1B64)
#define DSAF_INODE_VC0_IN_PKT_NUM_6_REG		   (0x1B68)
#define DSAF_INODE_VC0_IN_PKT_NUM_7_REG		   (0x1B6C)
#define DSAF_INODE_VC0_IN_PKT_NUM_8_REG		   (0x1B70)
#define DSAF_INODE_VC0_IN_PKT_NUM_9_REG		   (0x1B74)
#define DSAF_INODE_VC0_IN_PKT_NUM_10_REG		  (0x1B78)
#define DSAF_INODE_VC0_IN_PKT_NUM_11_REG		  (0x1B7C)
#define DSAF_INODE_VC0_IN_PKT_NUM_12_REG		  (0x1B80)
#define DSAF_INODE_VC0_IN_PKT_NUM_13_REG		  (0x1B84)
#define DSAF_INODE_VC0_IN_PKT_NUM_14_REG		  (0x1B88)
#define DSAF_INODE_VC0_IN_PKT_NUM_15_REG		  (0x1B8C)
#define DSAF_INODE_VC0_IN_PKT_NUM_16_REG		  (0x1B90)
#define DSAF_INODE_VC0_IN_PKT_NUM_17_REG		  (0x1B94)
#define DSAF_INODE_VC1_IN_PKT_NUM_0_REG		   (0x1C00)
#define DSAF_INODE_VC1_IN_PKT_NUM_1_REG		   (0x1C04)
#define DSAF_INODE_VC1_IN_PKT_NUM_2_REG		   (0x1C08)
#define DSAF_INODE_VC1_IN_PKT_NUM_3_REG		   (0x1C0C)
#define DSAF_INODE_VC1_IN_PKT_NUM_4_REG		   (0x1C10)
#define DSAF_INODE_VC1_IN_PKT_NUM_5_REG		   (0x1C14)
#define DSAF_SBM_CFG_REG_0_REG		(0x2000)
#define DSAF_SBM_CFG_REG_1_REG		(0x2080)
#define DSAF_SBM_CFG_REG_2_REG		(0x2100)
#define DSAF_SBM_CFG_REG_3_REG		(0x2180)
#define DSAF_SBM_CFG_REG_4_REG		(0x2200)
#define DSAF_SBM_CFG_REG_5_REG		(0x2280)
#define DSAF_SBM_CFG_REG_6_REG		(0x2300)
#define DSAF_SBM_CFG_REG_7_REG		(0x2380)
#define DSAF_SBM_CFG_REG_8_REG		(0x2400)
#define DSAF_SBM_CFG_REG_9_REG		(0x2480)
#define DSAF_SBM_CFG_REG_10_REG		(0x2500)
#define DSAF_SBM_CFG_REG_11_REG		(0x2580)
#define DSAF_SBM_CFG_REG_12_REG		(0x2600)
#define DSAF_SBM_CFG_REG_13_REG		(0x2680)
#define DSAF_SBM_CFG_REG_14_REG		(0x2700)
#define DSAF_SBM_CFG_REG_15_REG		(0x2780)
#define DSAF_SBM_CFG_REG_16_REG		(0x2800)
#define DSAF_SBM_CFG_REG_17_REG		(0x2880)
#define DSAF_SBM_BP_CFG_0_XGE_REG_0_REG		   (0x2004)
#define DSAF_SBM_BP_CFG_0_XGE_REG_1_REG		   (0x2084)
#define DSAF_SBM_BP_CFG_0_XGE_REG_2_REG		   (0x2104)
#define DSAF_SBM_BP_CFG_0_XGE_REG_3_REG		   (0x2184)
#define DSAF_SBM_BP_CFG_0_XGE_REG_4_REG		   (0x2204)
#define DSAF_SBM_BP_CFG_0_XGE_REG_5_REG		   (0x2284)
#define DSAF_SBM_BP_CFG_0_PPE_REG_0_REG		   (0x2304)
#define DSAF_SBM_BP_CFG_0_PPE_REG_1_REG		   (0x2384)
#define DSAF_SBM_BP_CFG_0_PPE_REG_2_REG		   (0x2404)
#define DSAF_SBM_BP_CFG_0_PPE_REG_3_REG		   (0x2484)
#define DSAF_SBM_BP_CFG_0_PPE_REG_4_REG		   (0x2504)
#define DSAF_SBM_BP_CFG_0_PPE_REG_5_REG		   (0x2584)
#define DSAF_SBM_BP_CFG_0_ROCEE_REG_0_REG		 (0x2604)
#define DSAF_SBM_BP_CFG_0_ROCEE_REG_1_REG		 (0x2684)
#define DSAF_SBM_BP_CFG_0_ROCEE_REG_2_REG		 (0x2704)
#define DSAF_SBM_BP_CFG_0_ROCEE_REG_3_REG		 (0x2784)
#define DSAF_SBM_BP_CFG_0_ROCEE_REG_4_REG		 (0x2804)
#define DSAF_SBM_BP_CFG_0_ROCEE_REG_5_REG		 (0x2884)
#define DSAF_SBM_BP_CFG_1_REG_0_REG		  (0x2008)
#define DSAF_SBM_BP_CFG_1_REG_1_REG		  (0x2088)
#define DSAF_SBM_BP_CFG_1_REG_2_REG		  (0x2108)
#define DSAF_SBM_BP_CFG_1_REG_3_REG		  (0x2188)
#define DSAF_SBM_BP_CFG_1_REG_4_REG		  (0x2208)
#define DSAF_SBM_BP_CFG_1_REG_5_REG		  (0x2288)
#define DSAF_SBM_BP_CFG_1_REG_6_REG		  (0x2308)
#define DSAF_SBM_BP_CFG_1_REG_7_REG		  (0x2388)
#define DSAF_SBM_BP_CFG_1_REG_8_REG		  (0x2408)
#define DSAF_SBM_BP_CFG_1_REG_9_REG		  (0x2488)
#define DSAF_SBM_BP_CFG_1_REG_10_REG		 (0x2508)
#define DSAF_SBM_BP_CFG_1_REG_11_REG		 (0x2588)
#define DSAF_SBM_BP_CFG_1_REG_12_REG		 (0x2608)
#define DSAF_SBM_BP_CFG_1_REG_13_REG		 (0x2688)
#define DSAF_SBM_BP_CFG_1_REG_14_REG		 (0x2708)
#define DSAF_SBM_BP_CFG_1_REG_15_REG		 (0x2788)
#define DSAF_SBM_BP_CFG_1_REG_16_REG		 (0x2808)
#define DSAF_SBM_BP_CFG_1_REG_17_REG		 (0x2888)
#define DSAF_SBM_BP_CFG_2_XGE_REG_0_REG		   (0x200C)
#define DSAF_SBM_BP_CFG_2_XGE_REG_1_REG		   (0x208C)
#define DSAF_SBM_BP_CFG_2_XGE_REG_2_REG		   (0x210C)
#define DSAF_SBM_BP_CFG_2_XGE_REG_3_REG		   (0x218C)
#define DSAF_SBM_BP_CFG_2_XGE_REG_4_REG		   (0x220C)
#define DSAF_SBM_BP_CFG_2_XGE_REG_5_REG		   (0x228C)
#define DSAF_SBM_BP_CFG_2_PPE_REG_0_REG		   (0x230C)
#define DSAF_SBM_BP_CFG_2_PPE_REG_1_REG		   (0x238C)
#define DSAF_SBM_BP_CFG_2_PPE_REG_2_REG		   (0x240C)
#define DSAF_SBM_BP_CFG_2_PPE_REG_3_REG		   (0x248C)
#define DSAF_SBM_BP_CFG_2_PPE_REG_4_REG		   (0x250C)
#define DSAF_SBM_BP_CFG_2_PPE_REG_5_REG		   (0x258C)
#define DSAF_SBM_BP_CFG_2_ROCEE_REG_0_REG		 (0x260C)
#define DSAF_SBM_BP_CFG_2_ROCEE_REG_1_REG		 (0x268C)
#define DSAF_SBM_BP_CFG_2_ROCEE_REG_2_REG		 (0x270C)
#define DSAF_SBM_BP_CFG_2_ROCEE_REG_3_REG		 (0x278C)
#define DSAF_SBM_BP_CFG_2_ROCEE_REG_4_REG		 (0x280C)
#define DSAF_SBM_BP_CFG_2_ROCEE_REG_5_REG		 (0x288C)
#define DSAF_SBM_FREE_CNT_0_0_REG		(0x2010)
#define DSAF_SBM_FREE_CNT_0_1_REG		(0x2090)
#define DSAF_SBM_FREE_CNT_0_2_REG		(0x2110)
#define DSAF_SBM_FREE_CNT_0_3_REG		(0x2190)
#define DSAF_SBM_FREE_CNT_0_4_REG		(0x2210)
#define DSAF_SBM_FREE_CNT_0_5_REG		(0x2290)
#define DSAF_SBM_FREE_CNT_0_6_REG		(0x2310)
#define DSAF_SBM_FREE_CNT_0_7_REG		(0x2390)
#define DSAF_SBM_FREE_CNT_0_8_REG		(0x2410)
#define DSAF_SBM_FREE_CNT_0_9_REG		(0x2490)
#define DSAF_SBM_FREE_CNT_0_10_REG		(0x2510)
#define DSAF_SBM_FREE_CNT_0_11_REG		(0x2590)
#define DSAF_SBM_FREE_CNT_0_12_REG		(0x2610)
#define DSAF_SBM_FREE_CNT_0_13_REG		(0x2690)
#define DSAF_SBM_FREE_CNT_0_14_REG		(0x2710)
#define DSAF_SBM_FREE_CNT_0_15_REG		(0x2790)
#define DSAF_SBM_FREE_CNT_0_16_REG		(0x2810)
#define DSAF_SBM_FREE_CNT_0_17_REG		(0x2890)
#define DSAF_SBM_FREE_CNT_1_0_REG		(0x2014)
#define DSAF_SBM_FREE_CNT_1_1_REG		(0x2094)
#define DSAF_SBM_FREE_CNT_1_2_REG		(0x2114)
#define DSAF_SBM_FREE_CNT_1_3_REG		(0x2194)
#define DSAF_SBM_FREE_CNT_1_4_REG		(0x2214)
#define DSAF_SBM_FREE_CNT_1_5_REG		(0x2294)
#define DSAF_SBM_FREE_CNT_1_6_REG		(0x2314)
#define DSAF_SBM_FREE_CNT_1_7_REG		(0x2394)
#define DSAF_SBM_FREE_CNT_1_8_REG		(0x2414)
#define DSAF_SBM_FREE_CNT_1_9_REG		(0x2494)
#define DSAF_SBM_FREE_CNT_1_10_REG		(0x2514)
#define DSAF_SBM_FREE_CNT_1_11_REG		(0x2594)
#define DSAF_SBM_FREE_CNT_1_12_REG		(0x2614)
#define DSAF_SBM_FREE_CNT_1_13_REG		(0x2694)
#define DSAF_SBM_FREE_CNT_1_14_REG		(0x2714)
#define DSAF_SBM_FREE_CNT_1_15_REG		(0x2794)
#define DSAF_SBM_FREE_CNT_1_16_REG		(0x2814)
#define DSAF_SBM_FREE_CNT_1_17_REG		(0x2894)
#define DSAF_SBM_BP_CNT_0_0_REG			  (0x2018)
#define DSAF_SBM_BP_CNT_0_1_REG			  (0x2098)
#define DSAF_SBM_BP_CNT_0_2_REG			  (0x2118)
#define DSAF_SBM_BP_CNT_0_3_REG		 (0x2198)
#define DSAF_SBM_BP_CNT_0_4_REG		 (0x2218)
#define DSAF_SBM_BP_CNT_0_5_REG		 (0x2298)
#define DSAF_SBM_BP_CNT_0_6_REG		 (0x2318)
#define DSAF_SBM_BP_CNT_0_7_REG		 (0x2398)
#define DSAF_SBM_BP_CNT_0_8_REG		 (0x2418)
#define DSAF_SBM_BP_CNT_0_9_REG		 (0x2498)
#define DSAF_SBM_BP_CNT_0_10_REG	(0x2518)
#define DSAF_SBM_BP_CNT_0_11_REG	(0x2598)
#define DSAF_SBM_BP_CNT_0_12_REG	(0x2618)
#define DSAF_SBM_BP_CNT_0_13_REG	(0x2698)
#define DSAF_SBM_BP_CNT_0_14_REG	(0x2718)
#define DSAF_SBM_BP_CNT_0_15_REG	(0x2798)
#define DSAF_SBM_BP_CNT_0_16_REG	(0x2818)
#define DSAF_SBM_BP_CNT_0_17_REG	(0x2898)
#define DSAF_SBM_BP_CNT_1_0_REG		 (0x201C)
#define DSAF_SBM_BP_CNT_1_1_REG		 (0x209C)
#define DSAF_SBM_BP_CNT_1_2_REG		 (0x211C)
#define DSAF_SBM_BP_CNT_1_3_REG		 (0x219C)
#define DSAF_SBM_BP_CNT_1_4_REG		 (0x221C)
#define DSAF_SBM_BP_CNT_1_5_REG		 (0x229C)
#define DSAF_SBM_BP_CNT_1_6_REG		 (0x231C)
#define DSAF_SBM_BP_CNT_1_7_REG		 (0x239C)
#define DSAF_SBM_BP_CNT_1_8_REG		 (0x241C)
#define DSAF_SBM_BP_CNT_1_9_REG		 (0x249C)
#define DSAF_SBM_BP_CNT_1_10_REG	(0x251C)
#define DSAF_SBM_BP_CNT_1_11_REG	(0x259C)
#define DSAF_SBM_BP_CNT_1_12_REG	(0x261C)
#define DSAF_SBM_BP_CNT_1_13_REG	(0x269C)
#define DSAF_SBM_BP_CNT_1_14_REG	(0x271C)
#define DSAF_SBM_BP_CNT_1_15_REG	(0x279C)
#define DSAF_SBM_BP_CNT_1_16_REG	(0x281C)
#define DSAF_SBM_BP_CNT_1_17_REG	(0x289C)
#define DSAF_SBM_BP_CNT_2_0_REG		 (0x2020)
#define DSAF_SBM_BP_CNT_2_1_REG		 (0x20A0)
#define DSAF_SBM_BP_CNT_2_2_REG		 (0x2120)
#define DSAF_SBM_BP_CNT_2_3_REG		 (0x21A0)
#define DSAF_SBM_BP_CNT_2_4_REG		 (0x2220)
#define DSAF_SBM_BP_CNT_2_5_REG		 (0x22A0)
#define DSAF_SBM_BP_CNT_2_6_REG		 (0x2320)
#define DSAF_SBM_BP_CNT_2_7_REG		 (0x23A0)
#define DSAF_SBM_BP_CNT_2_8_REG		 (0x2420)
#define DSAF_SBM_BP_CNT_2_9_REG		 (0x24A0)
#define DSAF_SBM_BP_CNT_2_10_REG	(0x2520)
#define DSAF_SBM_BP_CNT_2_11_REG	(0x25A0)
#define DSAF_SBM_BP_CNT_2_12_REG	(0x2620)
#define DSAF_SBM_BP_CNT_2_13_REG	(0x26A0)
#define DSAF_SBM_BP_CNT_2_14_REG	(0x2720)
#define DSAF_SBM_BP_CNT_2_15_REG	(0x27A0)
#define DSAF_SBM_BP_CNT_2_16_REG	(0x2820)
#define DSAF_SBM_BP_CNT_2_17_REG	(0x28A0)
#define DSAF_SBM_BP_CNT_3_0_REG		 (0x2024)
#define DSAF_SBM_BP_CNT_3_1_REG		 (0x20A4)
#define DSAF_SBM_BP_CNT_3_2_REG		 (0x2124)
#define DSAF_SBM_BP_CNT_3_3_REG		 (0x21A4)
#define DSAF_SBM_BP_CNT_3_4_REG		 (0x2224)
#define DSAF_SBM_BP_CNT_3_5_REG		 (0x22A4)
#define DSAF_SBM_BP_CNT_3_6_REG		 (0x2324)
#define DSAF_SBM_BP_CNT_3_7_REG		 (0x23A4)
#define DSAF_SBM_BP_CNT_3_8_REG		 (0x2424)
#define DSAF_SBM_BP_CNT_3_9_REG		 (0x24A4)
#define DSAF_SBM_BP_CNT_3_10_REG	(0x2524)
#define DSAF_SBM_BP_CNT_3_11_REG	(0x25A4)
#define DSAF_SBM_BP_CNT_3_12_REG	(0x2624)
#define DSAF_SBM_BP_CNT_3_13_REG	(0x26A4)
#define DSAF_SBM_BP_CNT_3_14_REG	(0x2724)
#define DSAF_SBM_BP_CNT_3_15_REG	(0x27A4)
#define DSAF_SBM_BP_CNT_3_16_REG	(0x2824)
#define DSAF_SBM_BP_CNT_3_17_REG	(0x28A4)
#define DSAF_SBM_INER_ST_0_REG		(0x2028)
#define DSAF_SBM_INER_ST_1_REG		(0x20A8)
#define DSAF_SBM_INER_ST_2_REG		(0x2128)
#define DSAF_SBM_INER_ST_3_REG		(0x21A8)
#define DSAF_SBM_INER_ST_4_REG		(0x2228)
#define DSAF_SBM_INER_ST_5_REG		(0x22A8)
#define DSAF_SBM_INER_ST_6_REG		(0x2328)
#define DSAF_SBM_INER_ST_7_REG		(0x23A8)
#define DSAF_SBM_INER_ST_8_REG		(0x2428)
#define DSAF_SBM_INER_ST_9_REG		(0x24A8)
#define DSAF_SBM_INER_ST_10_REG		 (0x2528)
#define DSAF_SBM_INER_ST_11_REG		 (0x25A8)
#define DSAF_SBM_INER_ST_12_REG		 (0x2628)
#define DSAF_SBM_INER_ST_13_REG		 (0x26A8)
#define DSAF_SBM_INER_ST_14_REG		 (0x2728)
#define DSAF_SBM_INER_ST_15_REG		 (0x27A8)
#define DSAF_SBM_INER_ST_16_REG		 (0x2828)
#define DSAF_SBM_INER_ST_17_REG		 (0x28A8)
#define DSAF_SBM_MIB_REQ_FAILED_TC_0_REG		  (0x202C)
#define DSAF_SBM_MIB_REQ_FAILED_TC_1_REG		  (0x20AC)
#define DSAF_SBM_MIB_REQ_FAILED_TC_2_REG		  (0x212C)
#define DSAF_SBM_MIB_REQ_FAILED_TC_3_REG		  (0x21AC)
#define DSAF_SBM_MIB_REQ_FAILED_TC_4_REG		  (0x222C)
#define DSAF_SBM_MIB_REQ_FAILED_TC_5_REG		  (0x22AC)
#define DSAF_SBM_MIB_REQ_FAILED_TC_6_REG		  (0x232C)
#define DSAF_SBM_MIB_REQ_FAILED_TC_7_REG		  (0x23AC)
#define DSAF_SBM_MIB_REQ_FAILED_TC_8_REG		  (0x242C)
#define DSAF_SBM_MIB_REQ_FAILED_TC_9_REG		  (0x24AC)
#define DSAF_SBM_MIB_REQ_FAILED_TC_10_REG		 (0x252C)
#define DSAF_SBM_MIB_REQ_FAILED_TC_11_REG		 (0x25AC)
#define DSAF_SBM_MIB_REQ_FAILED_TC_12_REG		 (0x262C)
#define DSAF_SBM_MIB_REQ_FAILED_TC_13_REG		 (0x26AC)
#define DSAF_SBM_MIB_REQ_FAILED_TC_14_REG		 (0x272C)
#define DSAF_SBM_MIB_REQ_FAILED_TC_15_REG		 (0x27AC)
#define DSAF_SBM_MIB_REQ_FAILED_TC_16_REG		 (0x282C)
#define DSAF_SBM_MIB_REQ_FAILED_TC_17_REG		 (0x28AC)
#define DSAF_SBM_LNK_INPORT_CNT_0_REG	(0x2030)
#define DSAF_SBM_LNK_INPORT_CNT_1_REG	(0x20B0)
#define DSAF_SBM_LNK_INPORT_CNT_2_REG	(0x2130)
#define DSAF_SBM_LNK_INPORT_CNT_3_REG	(0x21B0)
#define DSAF_SBM_LNK_INPORT_CNT_4_REG	(0x2230)
#define DSAF_SBM_LNK_INPORT_CNT_5_REG	(0x22B0)
#define DSAF_SBM_LNK_INPORT_CNT_6_REG	(0x2330)
#define DSAF_SBM_LNK_INPORT_CNT_7_REG	(0x23B0)
#define DSAF_SBM_LNK_INPORT_CNT_8_REG	(0x2430)
#define DSAF_SBM_LNK_INPORT_CNT_9_REG	(0x24B0)
#define DSAF_SBM_LNK_INPORT_CNT_10_REG		(0x2530)
#define DSAF_SBM_LNK_INPORT_CNT_11_REG		(0x25B0)
#define DSAF_SBM_LNK_INPORT_CNT_12_REG		(0x2630)
#define DSAF_SBM_LNK_INPORT_CNT_13_REG		(0x26B0)
#define DSAF_SBM_LNK_INPORT_CNT_14_REG		(0x2730)
#define DSAF_SBM_LNK_INPORT_CNT_15_REG		(0x27B0)
#define DSAF_SBM_LNK_INPORT_CNT_16_REG		(0x2830)
#define DSAF_SBM_LNK_INPORT_CNT_17_REG		(0x28B0)
#define DSAF_SBM_LNK_DROP_CNT_0_REG		  (0x2034)
#define DSAF_SBM_LNK_DROP_CNT_1_REG		  (0x20B4)
#define DSAF_SBM_LNK_DROP_CNT_2_REG		  (0x2134)
#define DSAF_SBM_LNK_DROP_CNT_3_REG		  (0x21B4)
#define DSAF_SBM_LNK_DROP_CNT_4_REG		  (0x2234)
#define DSAF_SBM_LNK_DROP_CNT_5_REG		  (0x22B4)
#define DSAF_SBM_LNK_DROP_CNT_6_REG		  (0x2334)
#define DSAF_SBM_LNK_DROP_CNT_7_REG		  (0x23B4)
#define DSAF_SBM_LNK_DROP_CNT_8_REG		  (0x2434)
#define DSAF_SBM_LNK_DROP_CNT_9_REG		  (0x24B4)
#define DSAF_SBM_LNK_DROP_CNT_10_REG		 (0x2534)
#define DSAF_SBM_LNK_DROP_CNT_11_REG		 (0x25B4)
#define DSAF_SBM_LNK_DROP_CNT_12_REG		 (0x2634)
#define DSAF_SBM_LNK_DROP_CNT_13_REG		 (0x26B4)
#define DSAF_SBM_LNK_DROP_CNT_14_REG		 (0x2734)
#define DSAF_SBM_LNK_DROP_CNT_15_REG		 (0x27B4)
#define DSAF_SBM_LNK_DROP_CNT_16_REG		 (0x2834)
#define DSAF_SBM_LNK_DROP_CNT_17_REG		 (0x28B4)
#define DSAF_SBM_INF_OUTPORT_CNT_0_REG		(0x2038)
#define DSAF_SBM_INF_OUTPORT_CNT_1_REG		(0x20B8)
#define DSAF_SBM_INF_OUTPORT_CNT_2_REG		(0x2138)
#define DSAF_SBM_INF_OUTPORT_CNT_3_REG		(0x21B8)
#define DSAF_SBM_INF_OUTPORT_CNT_4_REG		(0x2238)
#define DSAF_SBM_INF_OUTPORT_CNT_5_REG		(0x22B8)
#define DSAF_SBM_INF_OUTPORT_CNT_6_REG		(0x2338)
#define DSAF_SBM_INF_OUTPORT_CNT_7_REG		(0x23B8)
#define DSAF_SBM_INF_OUTPORT_CNT_8_REG		(0x2438)
#define DSAF_SBM_INF_OUTPORT_CNT_9_REG		(0x24B8)
#define DSAF_SBM_INF_OUTPORT_CNT_10_REG		   (0x2538)
#define DSAF_SBM_INF_OUTPORT_CNT_11_REG		   (0x25B8)
#define DSAF_SBM_INF_OUTPORT_CNT_12_REG		   (0x2638)
#define DSAF_SBM_INF_OUTPORT_CNT_13_REG		   (0x26B8)
#define DSAF_SBM_INF_OUTPORT_CNT_14_REG		   (0x2738)
#define DSAF_SBM_INF_OUTPORT_CNT_15_REG		   (0x27B8)
#define DSAF_SBM_INF_OUTPORT_CNT_16_REG		   (0x2838)
#define DSAF_SBM_INF_OUTPORT_CNT_17_REG		   (0x28B8)
#define DSAF_SBM_LNK_INPORT_TC0_CNT_0_REG		 (0x203C)
#define DSAF_SBM_LNK_INPORT_TC0_CNT_1_REG		 (0x20BC)
#define DSAF_SBM_LNK_INPORT_TC0_CNT_2_REG		 (0x213C)
#define DSAF_SBM_LNK_INPORT_TC0_CNT_3_REG		 (0x21BC)
#define DSAF_SBM_LNK_INPORT_TC0_CNT_4_REG		 (0x223C)
#define DSAF_SBM_LNK_INPORT_TC0_CNT_5_REG		 (0x22BC)
#define DSAF_SBM_LNK_INPORT_TC0_CNT_6_REG		 (0x233C)
#define DSAF_SBM_LNK_INPORT_TC0_CNT_7_REG		 (0x23BC)
#define DSAF_SBM_LNK_INPORT_TC0_CNT_8_REG		 (0x243C)
#define DSAF_SBM_LNK_INPORT_TC0_CNT_9_REG		 (0x24BC)
#define DSAF_SBM_LNK_INPORT_TC0_CNT_10_REG	(0x253C)
#define DSAF_SBM_LNK_INPORT_TC0_CNT_11_REG	(0x25BC)
#define DSAF_SBM_LNK_INPORT_TC0_CNT_12_REG	(0x263C)
#define DSAF_SBM_LNK_INPORT_TC0_CNT_13_REG	(0x26BC)
#define DSAF_SBM_LNK_INPORT_TC0_CNT_14_REG	(0x273C)
#define DSAF_SBM_LNK_INPORT_TC0_CNT_15_REG	(0x27BC)
#define DSAF_SBM_LNK_INPORT_TC0_CNT_16_REG	(0x283C)
#define DSAF_SBM_LNK_INPORT_TC0_CNT_17_REG	(0x28BC)
#define DSAF_SBM_LNK_INPORT_TC1_CNT_0_REG		 (0x2040)
#define DSAF_SBM_LNK_INPORT_TC1_CNT_1_REG		 (0x20C0)
#define DSAF_SBM_LNK_INPORT_TC1_CNT_2_REG		 (0x2140)
#define DSAF_SBM_LNK_INPORT_TC1_CNT_3_REG		 (0x21C0)
#define DSAF_SBM_LNK_INPORT_TC1_CNT_4_REG		 (0x2240)
#define DSAF_SBM_LNK_INPORT_TC1_CNT_5_REG		 (0x22C0)
#define DSAF_SBM_LNK_INPORT_TC1_CNT_6_REG		 (0x2340)
#define DSAF_SBM_LNK_INPORT_TC1_CNT_7_REG		 (0x23C0)
#define DSAF_SBM_LNK_INPORT_TC1_CNT_8_REG		 (0x2440)
#define DSAF_SBM_LNK_INPORT_TC1_CNT_9_REG		 (0x24C0)
#define DSAF_SBM_LNK_INPORT_TC1_CNT_10_REG	(0x2540)
#define DSAF_SBM_LNK_INPORT_TC1_CNT_11_REG	(0x25C0)
#define DSAF_SBM_LNK_INPORT_TC1_CNT_12_REG	(0x2640)
#define DSAF_SBM_LNK_INPORT_TC1_CNT_13_REG	(0x26C0)
#define DSAF_SBM_LNK_INPORT_TC1_CNT_14_REG	(0x2740)
#define DSAF_SBM_LNK_INPORT_TC1_CNT_15_REG	(0x27C0)
#define DSAF_SBM_LNK_INPORT_TC1_CNT_16_REG	(0x2840)
#define DSAF_SBM_LNK_INPORT_TC1_CNT_17_REG	(0x28C0)
#define DSAF_SBM_LNK_INPORT_TC2_CNT_0_REG		 (0x2044)
#define DSAF_SBM_LNK_INPORT_TC2_CNT_1_REG		 (0x20C4)
#define DSAF_SBM_LNK_INPORT_TC2_CNT_2_REG		 (0x2144)
#define DSAF_SBM_LNK_INPORT_TC2_CNT_3_REG		 (0x21C4)
#define DSAF_SBM_LNK_INPORT_TC2_CNT_4_REG		 (0x2244)
#define DSAF_SBM_LNK_INPORT_TC2_CNT_5_REG		 (0x22C4)
#define DSAF_SBM_LNK_INPORT_TC2_CNT_6_REG		 (0x2344)
#define DSAF_SBM_LNK_INPORT_TC2_CNT_7_REG		 (0x23C4)
#define DSAF_SBM_LNK_INPORT_TC2_CNT_8_REG		 (0x2444)
#define DSAF_SBM_LNK_INPORT_TC2_CNT_9_REG		 (0x24C4)
#define DSAF_SBM_LNK_INPORT_TC2_CNT_10_REG	(0x2544)
#define DSAF_SBM_LNK_INPORT_TC2_CNT_11_REG	(0x25C4)
#define DSAF_SBM_LNK_INPORT_TC2_CNT_12_REG	(0x2644)
#define DSAF_SBM_LNK_INPORT_TC2_CNT_13_REG	(0x26C4)
#define DSAF_SBM_LNK_INPORT_TC2_CNT_14_REG	(0x2744)
#define DSAF_SBM_LNK_INPORT_TC2_CNT_15_REG	(0x27C4)
#define DSAF_SBM_LNK_INPORT_TC2_CNT_16_REG	(0x2844)
#define DSAF_SBM_LNK_INPORT_TC2_CNT_17_REG	(0x28C4)
#define DSAF_SBM_LNK_INPORT_TC3_CNT_0_REG		 (0x2048)
#define DSAF_SBM_LNK_INPORT_TC3_CNT_1_REG		 (0x20C8)
#define DSAF_SBM_LNK_INPORT_TC3_CNT_2_REG		 (0x2148)
#define DSAF_SBM_LNK_INPORT_TC3_CNT_3_REG		 (0x21C8)
#define DSAF_SBM_LNK_INPORT_TC3_CNT_4_REG		 (0x2248)
#define DSAF_SBM_LNK_INPORT_TC3_CNT_5_REG		 (0x22C8)
#define DSAF_SBM_LNK_INPORT_TC3_CNT_6_REG		 (0x2348)
#define DSAF_SBM_LNK_INPORT_TC3_CNT_7_REG		 (0x23C8)
#define DSAF_SBM_LNK_INPORT_TC3_CNT_8_REG		 (0x2448)
#define DSAF_SBM_LNK_INPORT_TC3_CNT_9_REG		 (0x24C8)
#define DSAF_SBM_LNK_INPORT_TC3_CNT_10_REG	(0x2548)
#define DSAF_SBM_LNK_INPORT_TC3_CNT_11_REG	(0x25C8)
#define DSAF_SBM_LNK_INPORT_TC3_CNT_12_REG	(0x2648)
#define DSAF_SBM_LNK_INPORT_TC3_CNT_13_REG	(0x26C8)
#define DSAF_SBM_LNK_INPORT_TC3_CNT_14_REG	(0x2748)
#define DSAF_SBM_LNK_INPORT_TC3_CNT_15_REG	(0x27C8)
#define DSAF_SBM_LNK_INPORT_TC3_CNT_16_REG	(0x2848)
#define DSAF_SBM_LNK_INPORT_TC3_CNT_17_REG	(0x28C8)
#define DSAF_SBM_LNK_INPORT_TC4_CNT_0_REG		 (0x204C)
#define DSAF_SBM_LNK_INPORT_TC4_CNT_1_REG		 (0x20CC)
#define DSAF_SBM_LNK_INPORT_TC4_CNT_2_REG		 (0x214C)
#define DSAF_SBM_LNK_INPORT_TC4_CNT_3_REG		 (0x21CC)
#define DSAF_SBM_LNK_INPORT_TC4_CNT_4_REG		 (0x224C)
#define DSAF_SBM_LNK_INPORT_TC4_CNT_5_REG		 (0x22CC)
#define DSAF_SBM_LNK_INPORT_TC4_CNT_6_REG		 (0x234C)
#define DSAF_SBM_LNK_INPORT_TC4_CNT_7_REG		 (0x23CC)
#define DSAF_SBM_LNK_INPORT_TC4_CNT_8_REG		 (0x244C)
#define DSAF_SBM_LNK_INPORT_TC4_CNT_9_REG		 (0x24CC)
#define DSAF_SBM_LNK_INPORT_TC4_CNT_10_REG	(0x254C)
#define DSAF_SBM_LNK_INPORT_TC4_CNT_11_REG	(0x25CC)
#define DSAF_SBM_LNK_INPORT_TC4_CNT_12_REG	(0x264C)
#define DSAF_SBM_LNK_INPORT_TC4_CNT_13_REG	(0x26CC)
#define DSAF_SBM_LNK_INPORT_TC4_CNT_14_REG	(0x274C)
#define DSAF_SBM_LNK_INPORT_TC4_CNT_15_REG	(0x27CC)
#define DSAF_SBM_LNK_INPORT_TC4_CNT_16_REG	(0x284C)
#define DSAF_SBM_LNK_INPORT_TC4_CNT_17_REG	(0x28CC)
#define DSAF_SBM_LNK_INPORT_TC5_CNT_0_REG		 (0x2050)
#define DSAF_SBM_LNK_INPORT_TC5_CNT_1_REG		 (0x20D0)
#define DSAF_SBM_LNK_INPORT_TC5_CNT_2_REG		 (0x2150)
#define DSAF_SBM_LNK_INPORT_TC5_CNT_3_REG		 (0x21D0)
#define DSAF_SBM_LNK_INPORT_TC5_CNT_4_REG		 (0x2250)
#define DSAF_SBM_LNK_INPORT_TC5_CNT_5_REG		 (0x22D0)
#define DSAF_SBM_LNK_INPORT_TC5_CNT_6_REG		 (0x2350)
#define DSAF_SBM_LNK_INPORT_TC5_CNT_7_REG		 (0x23D0)
#define DSAF_SBM_LNK_INPORT_TC5_CNT_8_REG		 (0x2450)
#define DSAF_SBM_LNK_INPORT_TC5_CNT_9_REG		 (0x24D0)
#define DSAF_SBM_LNK_INPORT_TC5_CNT_10_REG	(0x2550)
#define DSAF_SBM_LNK_INPORT_TC5_CNT_11_REG	(0x25D0)
#define DSAF_SBM_LNK_INPORT_TC5_CNT_12_REG	(0x2650)
#define DSAF_SBM_LNK_INPORT_TC5_CNT_13_REG	(0x26D0)
#define DSAF_SBM_LNK_INPORT_TC5_CNT_14_REG	(0x2750)
#define DSAF_SBM_LNK_INPORT_TC5_CNT_15_REG	(0x27D0)
#define DSAF_SBM_LNK_INPORT_TC5_CNT_16_REG	(0x2850)
#define DSAF_SBM_LNK_INPORT_TC5_CNT_17_REG	(0x28D0)
#define DSAF_SBM_LNK_INPORT_TC6_CNT_0_REG		 (0x2054)
#define DSAF_SBM_LNK_INPORT_TC6_CNT_1_REG		 (0x20D4)
#define DSAF_SBM_LNK_INPORT_TC6_CNT_2_REG		 (0x2154)
#define DSAF_SBM_LNK_INPORT_TC6_CNT_3_REG		 (0x21D4)
#define DSAF_SBM_LNK_INPORT_TC6_CNT_4_REG		 (0x2254)
#define DSAF_SBM_LNK_INPORT_TC6_CNT_5_REG		 (0x22D4)
#define DSAF_SBM_LNK_INPORT_TC6_CNT_6_REG		 (0x2354)
#define DSAF_SBM_LNK_INPORT_TC6_CNT_7_REG		 (0x23D4)
#define DSAF_SBM_LNK_INPORT_TC6_CNT_8_REG		 (0x2454)
#define DSAF_SBM_LNK_INPORT_TC6_CNT_9_REG		 (0x24D4)
#define DSAF_SBM_LNK_INPORT_TC6_CNT_10_REG	(0x2554)
#define DSAF_SBM_LNK_INPORT_TC6_CNT_11_REG	(0x25D4)
#define DSAF_SBM_LNK_INPORT_TC6_CNT_12_REG	(0x2654)
#define DSAF_SBM_LNK_INPORT_TC6_CNT_13_REG	(0x26D4)
#define DSAF_SBM_LNK_INPORT_TC6_CNT_14_REG	(0x2754)
#define DSAF_SBM_LNK_INPORT_TC6_CNT_15_REG	(0x27D4)
#define DSAF_SBM_LNK_INPORT_TC6_CNT_16_REG	(0x2854)
#define DSAF_SBM_LNK_INPORT_TC6_CNT_17_REG	(0x28D4)
#define DSAF_SBM_LNK_INPORT_TC7_CNT_0_REG		 (0x2058)
#define DSAF_SBM_LNK_INPORT_TC7_CNT_1_REG		 (0x20D8)
#define DSAF_SBM_LNK_INPORT_TC7_CNT_2_REG		 (0x2158)
#define DSAF_SBM_LNK_INPORT_TC7_CNT_3_REG		 (0x21D8)
#define DSAF_SBM_LNK_INPORT_TC7_CNT_4_REG		 (0x2258)
#define DSAF_SBM_LNK_INPORT_TC7_CNT_5_REG		 (0x22D8)
#define DSAF_SBM_LNK_INPORT_TC7_CNT_6_REG		 (0x2358)
#define DSAF_SBM_LNK_INPORT_TC7_CNT_7_REG		 (0x23D8)
#define DSAF_SBM_LNK_INPORT_TC7_CNT_8_REG		 (0x2458)
#define DSAF_SBM_LNK_INPORT_TC7_CNT_9_REG		 (0x24D8)
#define DSAF_SBM_LNK_INPORT_TC7_CNT_10_REG	(0x2558)
#define DSAF_SBM_LNK_INPORT_TC7_CNT_11_REG	(0x25D8)
#define DSAF_SBM_LNK_INPORT_TC7_CNT_12_REG	(0x2658)
#define DSAF_SBM_LNK_INPORT_TC7_CNT_13_REG	(0x26D8)
#define DSAF_SBM_LNK_INPORT_TC7_CNT_14_REG	(0x2758)
#define DSAF_SBM_LNK_INPORT_TC7_CNT_15_REG	(0x27D8)
#define DSAF_SBM_LNK_INPORT_TC7_CNT_16_REG	(0x2858)
#define DSAF_SBM_LNK_INPORT_TC7_CNT_17_REG	(0x28D8)
#define DSAF_SBM_LNK_REQ_CNT_0_REG		(0x205C)
#define DSAF_SBM_LNK_REQ_CNT_1_REG		(0x20DC)
#define DSAF_SBM_LNK_REQ_CNT_2_REG		(0x215C)
#define DSAF_SBM_LNK_REQ_CNT_3_REG		(0x21DC)
#define DSAF_SBM_LNK_REQ_CNT_4_REG		(0x225C)
#define DSAF_SBM_LNK_REQ_CNT_5_REG		(0x22DC)
#define DSAF_SBM_LNK_REQ_CNT_6_REG		(0x235C)
#define DSAF_SBM_LNK_REQ_CNT_7_REG		(0x23DC)
#define DSAF_SBM_LNK_REQ_CNT_8_REG		(0x245C)
#define DSAF_SBM_LNK_REQ_CNT_9_REG		(0x24DC)
#define DSAF_SBM_LNK_REQ_CNT_10_REG		  (0x255C)
#define DSAF_SBM_LNK_REQ_CNT_11_REG		  (0x25DC)
#define DSAF_SBM_LNK_REQ_CNT_12_REG		  (0x265C)
#define DSAF_SBM_LNK_REQ_CNT_13_REG		  (0x26DC)
#define DSAF_SBM_LNK_REQ_CNT_14_REG		  (0x275C)
#define DSAF_SBM_LNK_REQ_CNT_15_REG		  (0x27DC)
#define DSAF_SBM_LNK_REQ_CNT_16_REG		  (0x285C)
#define DSAF_SBM_LNK_REQ_CNT_17_REG		  (0x28DC)
#define DSAF_SBM_LNK_RELS_CNT_0_REG		  (0x2060)
#define DSAF_SBM_LNK_RELS_CNT_1_REG		  (0x20E0)
#define DSAF_SBM_LNK_RELS_CNT_2_REG		  (0x2160)
#define DSAF_SBM_LNK_RELS_CNT_3_REG		  (0x21E0)
#define DSAF_SBM_LNK_RELS_CNT_4_REG		  (0x2260)
#define DSAF_SBM_LNK_RELS_CNT_5_REG		  (0x22E0)
#define DSAF_SBM_LNK_RELS_CNT_6_REG		  (0x2360)
#define DSAF_SBM_LNK_RELS_CNT_7_REG		  (0x23E0)
#define DSAF_SBM_LNK_RELS_CNT_8_REG		  (0x2460)
#define DSAF_SBM_LNK_RELS_CNT_9_REG		  (0x24E0)
#define DSAF_SBM_LNK_RELS_CNT_10_REG		 (0x2560)
#define DSAF_SBM_LNK_RELS_CNT_11_REG		 (0x25E0)
#define DSAF_SBM_LNK_RELS_CNT_12_REG		 (0x2660)
#define DSAF_SBM_LNK_RELS_CNT_13_REG		 (0x26E0)
#define DSAF_SBM_LNK_RELS_CNT_14_REG		 (0x2760)
#define DSAF_SBM_LNK_RELS_CNT_15_REG		 (0x27E0)
#define DSAF_SBM_LNK_RELS_CNT_16_REG		 (0x2860)
#define DSAF_SBM_LNK_RELS_CNT_17_REG		 (0x28E0)
#define DSAF_SBM_BP_CFG_3_REG_0_REG		  (0x2068)
#define DSAF_SBM_BP_CFG_3_REG_1_REG		  (0x20E8)
#define DSAF_SBM_BP_CFG_3_REG_2_REG		  (0x2168)
#define DSAF_SBM_BP_CFG_3_REG_3_REG		  (0x21E8)
#define DSAF_SBM_BP_CFG_3_REG_4_REG		  (0x2268)
#define DSAF_SBM_BP_CFG_3_REG_5_REG		  (0x22E8)
#define DSAF_SBM_BP_CFG_3_REG_6_REG		  (0x2368)
#define DSAF_SBM_BP_CFG_3_REG_7_REG		  (0x23E8)
#define DSAF_SBM_BP_CFG_3_REG_8_REG		  (0x2468)
#define DSAF_SBM_BP_CFG_3_REG_9_REG		  (0x24E8)
#define DSAF_SBM_BP_CFG_3_REG_10_REG		 (0x2568)
#define DSAF_SBM_BP_CFG_3_REG_11_REG		 (0x25E8)
#define DSAF_SBM_BP_CFG_3_REG_12_REG		 (0x2668)
#define DSAF_SBM_BP_CFG_3_REG_13_REG		 (0x26E8)
#define DSAF_SBM_BP_CFG_3_REG_14_REG		 (0x2768)
#define DSAF_SBM_BP_CFG_3_REG_15_REG		 (0x27E8)
#define DSAF_SBM_BP_CFG_3_REG_16_REG		 (0x2868)
#define DSAF_SBM_BP_CFG_3_REG_17_REG		 (0x28E8)
#define DSAF_SBM_BP_CFG_4_REG_0_REG		  (0x206C)
#define DSAF_SBM_BP_CFG_4_REG_1_REG		  (0x20EC)
#define DSAF_SBM_BP_CFG_4_REG_2_REG		  (0x216C)
#define DSAF_SBM_BP_CFG_4_REG_3_REG		  (0x21EC)
#define DSAF_SBM_BP_CFG_4_REG_4_REG		  (0x226C)
#define DSAF_SBM_BP_CFG_4_REG_5_REG		  (0x22EC)
#define DSAF_SBM_BP_CFG_4_REG_6_REG		  (0x236C)
#define DSAF_SBM_BP_CFG_4_REG_7_REG		  (0x23EC)
#define DSAF_SBM_BP_CFG_4_REG_8_REG		  (0x246C)
#define DSAF_SBM_BP_CFG_4_REG_9_REG		  (0x24EC)
#define DSAF_SBM_BP_CFG_4_REG_10_REG		 (0x256C)
#define DSAF_SBM_BP_CFG_4_REG_11_REG		 (0x25EC)
#define DSAF_SBM_BP_CFG_4_REG_12_REG		 (0x266C)
#define DSAF_SBM_BP_CFG_4_REG_13_REG		 (0x26EC)
#define DSAF_SBM_BP_CFG_4_REG_14_REG		 (0x276C)
#define DSAF_SBM_BP_CFG_4_REG_15_REG		 (0x27EC)
#define DSAF_SBM_BP_CFG_4_REG_16_REG		 (0x286C)
#define DSAF_SBM_BP_CFG_4_REG_17_REG		 (0x28EC)
#define DSAF_XOD_ETS_TSA_TC0_TC3_CFG_0_REG	(0x3000)
#define DSAF_XOD_ETS_TSA_TC0_TC3_CFG_1_REG	(0x3090)
#define DSAF_XOD_ETS_TSA_TC0_TC3_CFG_2_REG	(0x3120)
#define DSAF_XOD_ETS_TSA_TC0_TC3_CFG_3_REG	(0x31B0)
#define DSAF_XOD_ETS_TSA_TC0_TC3_CFG_4_REG	(0x3240)
#define DSAF_XOD_ETS_TSA_TC0_TC3_CFG_5_REG	(0x32D0)
#define DSAF_XOD_ETS_TSA_TC0_TC3_CFG_6_REG	(0x3360)
#define DSAF_XOD_ETS_TSA_TC0_TC3_CFG_7_REG	(0x33F0)
#define DSAF_XOD_ETS_TSA_TC4_TC7_CFG_0_REG	(0x3004)
#define DSAF_XOD_ETS_TSA_TC4_TC7_CFG_1_REG	(0x3094)
#define DSAF_XOD_ETS_TSA_TC4_TC7_CFG_2_REG	(0x3124)
#define DSAF_XOD_ETS_TSA_TC4_TC7_CFG_3_REG	(0x31B4)
#define DSAF_XOD_ETS_TSA_TC4_TC7_CFG_4_REG	(0x3244)
#define DSAF_XOD_ETS_TSA_TC4_TC7_CFG_5_REG	(0x32D4)
#define DSAF_XOD_ETS_TSA_TC4_TC7_CFG_6_REG	(0x3364)
#define DSAF_XOD_ETS_TSA_TC4_TC7_CFG_7_REG	(0x33F4)
#define DSAF_XOD_ETS_BW_TC0_TC3_CFG_0_REG		 (0x3008)
#define DSAF_XOD_ETS_BW_TC0_TC3_CFG_1_REG		 (0x3098)
#define DSAF_XOD_ETS_BW_TC0_TC3_CFG_2_REG		 (0x3128)
#define DSAF_XOD_ETS_BW_TC0_TC3_CFG_3_REG		 (0x31B8)
#define DSAF_XOD_ETS_BW_TC0_TC3_CFG_4_REG		 (0x3248)
#define DSAF_XOD_ETS_BW_TC0_TC3_CFG_5_REG		 (0x32D8)
#define DSAF_XOD_ETS_BW_TC0_TC3_CFG_6_REG		 (0x3368)
#define DSAF_XOD_ETS_BW_TC0_TC3_CFG_7_REG		 (0x33F8)
#define DSAF_XOD_ETS_BW_TC4_TC7_CFG_0_REG		 (0x300C)
#define DSAF_XOD_ETS_BW_TC4_TC7_CFG_1_REG		 (0x309C)
#define DSAF_XOD_ETS_BW_TC4_TC7_CFG_2_REG		 (0x312C)
#define DSAF_XOD_ETS_BW_TC4_TC7_CFG_3_REG		 (0x31BC)
#define DSAF_XOD_ETS_BW_TC4_TC7_CFG_4_REG		 (0x324C)
#define DSAF_XOD_ETS_BW_TC4_TC7_CFG_5_REG		 (0x32DC)
#define DSAF_XOD_ETS_BW_TC4_TC7_CFG_6_REG		 (0x336C)
#define DSAF_XOD_ETS_BW_TC4_TC7_CFG_7_REG		 (0x33FC)
#define DSAF_XOD_ETS_BW_OFFSET_CFG_0_REG		  (0x3010)
#define DSAF_XOD_ETS_BW_OFFSET_CFG_1_REG		  (0x30A0)
#define DSAF_XOD_ETS_BW_OFFSET_CFG_2_REG		  (0x3130)
#define DSAF_XOD_ETS_BW_OFFSET_CFG_3_REG		  (0x31C0)
#define DSAF_XOD_ETS_BW_OFFSET_CFG_4_REG		  (0x3250)
#define DSAF_XOD_ETS_BW_OFFSET_CFG_5_REG		  (0x32E0)
#define DSAF_XOD_ETS_BW_OFFSET_CFG_6_REG		  (0x3370)
#define DSAF_XOD_ETS_BW_OFFSET_CFG_7_REG		  (0x3400)
#define DSAF_XOD_ETS_TOKEN_CFG_0_REG		 (0x3014)
#define DSAF_XOD_ETS_TOKEN_CFG_1_REG		 (0x30A4)
#define DSAF_XOD_ETS_TOKEN_CFG_2_REG		 (0x3134)
#define DSAF_XOD_ETS_TOKEN_CFG_3_REG		 (0x31C4)
#define DSAF_XOD_ETS_TOKEN_CFG_4_REG		 (0x3254)
#define DSAF_XOD_ETS_TOKEN_CFG_5_REG		 (0x32E4)
#define DSAF_XOD_ETS_TOKEN_CFG_6_REG		 (0x3374)
#define DSAF_XOD_ETS_TOKEN_CFG_7_REG		 (0x3404)
#define DSAF_XOD_PFS_CFG_0_0_REG	(0x3018)
#define DSAF_XOD_PFS_CFG_0_1_REG	(0x30A8)
#define DSAF_XOD_PFS_CFG_0_2_REG	(0x3138)
#define DSAF_XOD_PFS_CFG_0_3_REG	(0x31C8)
#define DSAF_XOD_PFS_CFG_0_4_REG	(0x3258)
#define DSAF_XOD_PFS_CFG_0_5_REG	(0x32E8)
#define DSAF_XOD_PFS_CFG_1_0_REG	(0x301C)
#define DSAF_XOD_PFS_CFG_1_1_REG	(0x30AC)
#define DSAF_XOD_PFS_CFG_1_2_REG	(0x313C)
#define DSAF_XOD_PFS_CFG_1_3_REG	(0x31CC)
#define DSAF_XOD_PFS_CFG_1_4_REG	(0x325C)
#define DSAF_XOD_PFS_CFG_1_5_REG	(0x32EC)
#define DSAF_XOD_PFS_CFG_2_0_REG	(0x3020)
#define DSAF_XOD_PFS_CFG_2_1_REG	(0x30B0)
#define DSAF_XOD_PFS_CFG_2_2_REG	(0x3140)
#define DSAF_XOD_PFS_CFG_2_3_REG	(0x31D0)
#define DSAF_XOD_PFS_CFG_2_4_REG	(0x3260)
#define DSAF_XOD_PFS_CFG_2_5_REG	(0x32F0)
#define DSAF_XOD_GNT_L_0_REG		(0x3024)
#define DSAF_XOD_GNT_L_1_REG		(0x30B4)
#define DSAF_XOD_GNT_L_2_REG		(0x3144)
#define DSAF_XOD_GNT_L_3_REG		(0x31D4)
#define DSAF_XOD_GNT_L_4_REG		(0x3264)
#define DSAF_XOD_GNT_L_5_REG		(0x32F4)
#define DSAF_XOD_GNT_L_6_REG		(0x3384)
#define DSAF_XOD_GNT_L_7_REG		(0x3414)
#define DSAF_XOD_GNT_L_8_REG		(0x34A4)
#define DSAF_XOD_GNT_L_9_REG		(0x3534)
#define DSAF_XOD_GNT_L_10_REG			(0x35C4)
#define DSAF_XOD_GNT_L_11_REG			(0x3654)
#define DSAF_XOD_GNT_L_12_REG			(0x36E4)
#define DSAF_XOD_GNT_L_13_REG			(0x3774)
#define DSAF_XOD_GNT_L_14_REG			(0x3804)
#define DSAF_XOD_GNT_L_15_REG			(0x3894)
#define DSAF_XOD_GNT_L_16_REG			(0x3924)
#define DSAF_XOD_GNT_L_17_REG			(0x39B4)
#define DSAF_XOD_GNT_H_0_REG		(0x3028)
#define DSAF_XOD_GNT_H_1_REG		(0x30B8)
#define DSAF_XOD_GNT_H_2_REG		(0x3148)
#define DSAF_XOD_GNT_H_3_REG		(0x31D8)
#define DSAF_XOD_GNT_H_4_REG		(0x3268)
#define DSAF_XOD_GNT_H_5_REG		(0x32F8)
#define DSAF_XOD_GNT_H_6_REG		(0x3388)
#define DSAF_XOD_GNT_H_7_REG		(0x3418)
#define DSAF_XOD_GNT_H_8_REG		(0x34A8)
#define DSAF_XOD_GNT_H_9_REG		(0x3538)
#define DSAF_XOD_GNT_H_10_REG		(0x35C8)
#define DSAF_XOD_GNT_H_11_REG		(0x3658)
#define DSAF_XOD_GNT_H_12_REG		(0x36E8)
#define DSAF_XOD_GNT_H_13_REG		(0x3778)
#define DSAF_XOD_GNT_H_14_REG		(0x3808)
#define DSAF_XOD_GNT_H_15_REG		(0x3898)
#define DSAF_XOD_GNT_H_16_REG		(0x3928)
#define DSAF_XOD_GNT_H_17_REG		(0x39B8)
#define DSAF_XOD_CONNECT_STATE_0_REG		 (0x302C)
#define DSAF_XOD_CONNECT_STATE_1_REG		 (0x30BC)
#define DSAF_XOD_CONNECT_STATE_2_REG		 (0x314C)
#define DSAF_XOD_CONNECT_STATE_3_REG		 (0x31DC)
#define DSAF_XOD_CONNECT_STATE_4_REG		 (0x326C)
#define DSAF_XOD_CONNECT_STATE_5_REG		 (0x32FC)
#define DSAF_XOD_CONNECT_STATE_6_REG		 (0x338C)
#define DSAF_XOD_CONNECT_STATE_7_REG		 (0x341C)
#define DSAF_XOD_CONNECT_STATE_8_REG		 (0x34AC)
#define DSAF_XOD_CONNECT_STATE_9_REG		 (0x353C)
#define DSAF_XOD_CONNECT_STATE_10_REG	(0x35CC)
#define DSAF_XOD_CONNECT_STATE_11_REG	(0x365C)
#define DSAF_XOD_CONNECT_STATE_12_REG	(0x36EC)
#define DSAF_XOD_CONNECT_STATE_13_REG	(0x377C)
#define DSAF_XOD_CONNECT_STATE_14_REG	(0x380C)
#define DSAF_XOD_CONNECT_STATE_15_REG	(0x389C)
#define DSAF_XOD_CONNECT_STATE_16_REG	(0x392C)
#define DSAF_XOD_CONNECT_STATE_17_REG	(0x39BC)
#define DSAF_XOD_RCVPKT_CNT_0_REG		(0x3030)
#define DSAF_XOD_RCVPKT_CNT_1_REG		(0x30C0)
#define DSAF_XOD_RCVPKT_CNT_2_REG		(0x3150)
#define DSAF_XOD_RCVPKT_CNT_3_REG		(0x31E0)
#define DSAF_XOD_RCVPKT_CNT_4_REG		(0x3270)
#define DSAF_XOD_RCVPKT_CNT_5_REG		(0x3300)
#define DSAF_XOD_RCVPKT_CNT_6_REG		(0x3390)
#define DSAF_XOD_RCVPKT_CNT_7_REG		(0x3420)
#define DSAF_XOD_RCVPKT_CNT_8_REG		(0x34B0)
#define DSAF_XOD_RCVPKT_CNT_9_REG		(0x3540)
#define DSAF_XOD_RCVPKT_CNT_10_REG		(0x35D0)
#define DSAF_XOD_RCVPKT_CNT_11_REG		(0x3660)
#define DSAF_XOD_RCVPKT_CNT_12_REG		(0x36F0)
#define DSAF_XOD_RCVPKT_CNT_13_REG		(0x3780)
#define DSAF_XOD_RCVPKT_CNT_14_REG		(0x3810)
#define DSAF_XOD_RCVPKT_CNT_15_REG		(0x38A0)
#define DSAF_XOD_RCVPKT_CNT_16_REG		(0x3930)
#define DSAF_XOD_RCVPKT_CNT_17_REG		(0x39C0)
#define DSAF_XOD_RCVTC0_CNT_0_REG		(0x3034)
#define DSAF_XOD_RCVTC0_CNT_1_REG		(0x30C4)
#define DSAF_XOD_RCVTC0_CNT_2_REG		(0x3154)
#define DSAF_XOD_RCVTC0_CNT_3_REG		(0x31E4)
#define DSAF_XOD_RCVTC0_CNT_4_REG		(0x3274)
#define DSAF_XOD_RCVTC0_CNT_5_REG		(0x3304)
#define DSAF_XOD_RCVTC0_CNT_6_REG		(0x3394)
#define DSAF_XOD_RCVTC0_CNT_7_REG		(0x3424)
#define DSAF_XOD_RCVTC0_CNT_8_REG		(0x34B4)
#define DSAF_XOD_RCVTC0_CNT_9_REG		(0x3544)
#define DSAF_XOD_RCVTC0_CNT_10_REG			(0x35D4)
#define DSAF_XOD_RCVTC0_CNT_11_REG			(0x3664)
#define DSAF_XOD_RCVTC0_CNT_12_REG			(0x36F4)
#define DSAF_XOD_RCVTC0_CNT_13_REG			(0x3784)
#define DSAF_XOD_RCVTC0_CNT_14_REG			(0x3814)
#define DSAF_XOD_RCVTC0_CNT_15_REG			(0x38A4)
#define DSAF_XOD_RCVTC0_CNT_16_REG			(0x3934)
#define DSAF_XOD_RCVTC0_CNT_17_REG			(0x39C4)
#define DSAF_XOD_RCVTC1_CNT_0_REG		(0x3038)
#define DSAF_XOD_RCVTC1_CNT_1_REG		(0x30C8)
#define DSAF_XOD_RCVTC1_CNT_2_REG		(0x3158)
#define DSAF_XOD_RCVTC1_CNT_3_REG		(0x31E8)
#define DSAF_XOD_RCVTC1_CNT_4_REG		(0x3278)
#define DSAF_XOD_RCVTC1_CNT_5_REG		(0x3308)
#define DSAF_XOD_RCVTC1_CNT_6_REG		(0x3398)
#define DSAF_XOD_RCVTC1_CNT_7_REG		(0x3428)
#define DSAF_XOD_RCVTC1_CNT_8_REG		(0x34B8)
#define DSAF_XOD_RCVTC1_CNT_9_REG		(0x3548)
#define DSAF_XOD_RCVTC1_CNT_10_REG			(0x35D8)
#define DSAF_XOD_RCVTC1_CNT_11_REG			(0x3668)
#define DSAF_XOD_RCVTC1_CNT_12_REG			(0x36F8)
#define DSAF_XOD_RCVTC1_CNT_13_REG			(0x3788)
#define DSAF_XOD_RCVTC1_CNT_14_REG			(0x3818)
#define DSAF_XOD_RCVTC1_CNT_15_REG			(0x38A8)
#define DSAF_XOD_RCVTC1_CNT_16_REG			(0x3938)
#define DSAF_XOD_RCVTC1_CNT_17_REG			(0x39C8)
#define DSAF_XOD_RCVTC2_CNT_0_REG		(0x303C)
#define DSAF_XOD_RCVTC2_CNT_1_REG		(0x30CC)
#define DSAF_XOD_RCVTC2_CNT_2_REG		(0x315C)
#define DSAF_XOD_RCVTC2_CNT_3_REG		(0x31EC)
#define DSAF_XOD_RCVTC2_CNT_4_REG		(0x327C)
#define DSAF_XOD_RCVTC2_CNT_5_REG		(0x330C)
#define DSAF_XOD_RCVTC2_CNT_6_REG		(0x339C)
#define DSAF_XOD_RCVTC2_CNT_7_REG		(0x342C)
#define DSAF_XOD_RCVTC2_CNT_8_REG		(0x34BC)
#define DSAF_XOD_RCVTC2_CNT_9_REG		(0x354C)
#define DSAF_XOD_RCVTC2_CNT_10_REG			(0x35DC)
#define DSAF_XOD_RCVTC2_CNT_11_REG			(0x366C)
#define DSAF_XOD_RCVTC2_CNT_12_REG			(0x36FC)
#define DSAF_XOD_RCVTC2_CNT_13_REG			(0x378C)
#define DSAF_XOD_RCVTC2_CNT_14_REG			(0x381C)
#define DSAF_XOD_RCVTC2_CNT_15_REG			(0x38AC)
#define DSAF_XOD_RCVTC2_CNT_16_REG			(0x393C)
#define DSAF_XOD_RCVTC2_CNT_17_REG			(0x39CC)
#define DSAF_XOD_RCVTC3_CNT_0_REG		(0x3040)
#define DSAF_XOD_RCVTC3_CNT_1_REG		(0x30D0)
#define DSAF_XOD_RCVTC3_CNT_2_REG		(0x3160)
#define DSAF_XOD_RCVTC3_CNT_3_REG		(0x31F0)
#define DSAF_XOD_RCVTC3_CNT_4_REG		(0x3280)
#define DSAF_XOD_RCVTC3_CNT_5_REG		(0x3310)
#define DSAF_XOD_RCVTC3_CNT_6_REG		(0x33A0)
#define DSAF_XOD_RCVTC3_CNT_7_REG		(0x3430)
#define DSAF_XOD_RCVTC3_CNT_8_REG		(0x34C0)
#define DSAF_XOD_RCVTC3_CNT_9_REG		(0x3550)
#define DSAF_XOD_RCVTC3_CNT_10_REG			(0x35E0)
#define DSAF_XOD_RCVTC3_CNT_11_REG			(0x3670)
#define DSAF_XOD_RCVTC3_CNT_12_REG			(0x3700)
#define DSAF_XOD_RCVTC3_CNT_13_REG			(0x3790)
#define DSAF_XOD_RCVTC3_CNT_14_REG			(0x3820)
#define DSAF_XOD_RCVTC3_CNT_15_REG			(0x38B0)
#define DSAF_XOD_RCVTC3_CNT_16_REG			(0x3940)
#define DSAF_XOD_RCVTC3_CNT_17_REG			(0x39D0)
#define DSAF_XOD_RCVVC0_CNT_0_REG		(0x3044)
#define DSAF_XOD_RCVVC0_CNT_1_REG		(0x30D4)
#define DSAF_XOD_RCVVC0_CNT_2_REG		(0x3164)
#define DSAF_XOD_RCVVC0_CNT_3_REG		(0x31F4)
#define DSAF_XOD_RCVVC0_CNT_4_REG		(0x3284)
#define DSAF_XOD_RCVVC0_CNT_5_REG		(0x3314)
#define DSAF_XOD_RCVVC0_CNT_6_REG		(0x33A4)
#define DSAF_XOD_RCVVC0_CNT_7_REG		(0x3434)
#define DSAF_XOD_RCVVC0_CNT_8_REG		(0x34C4)
#define DSAF_XOD_RCVVC0_CNT_9_REG		(0x3554)
#define DSAF_XOD_RCVVC0_CNT_10_REG			(0x35E4)
#define DSAF_XOD_RCVVC0_CNT_11_REG			(0x3674)
#define DSAF_XOD_RCVVC0_CNT_12_REG			(0x3704)
#define DSAF_XOD_RCVVC0_CNT_13_REG			(0x3794)
#define DSAF_XOD_RCVVC0_CNT_14_REG			(0x3824)
#define DSAF_XOD_RCVVC0_CNT_15_REG			(0x38B4)
#define DSAF_XOD_RCVVC0_CNT_16_REG			(0x3944)
#define DSAF_XOD_RCVVC0_CNT_17_REG			(0x39D4)
#define DSAF_XOD_RCVVC1_CNT_0_REG		(0x3048)
#define DSAF_XOD_RCVVC1_CNT_1_REG		(0x30D8)
#define DSAF_XOD_RCVVC1_CNT_2_REG		(0x3168)
#define DSAF_XOD_RCVVC1_CNT_3_REG		(0x31F8)
#define DSAF_XOD_RCVVC1_CNT_4_REG		(0x3288)
#define DSAF_XOD_RCVVC1_CNT_5_REG		(0x3318)
#define DSAF_XOD_RCVVC1_CNT_6_REG		(0x33A8)
#define DSAF_XOD_RCVVC1_CNT_7_REG		(0x3438)
#define DSAF_XOD_RCVVC1_CNT_8_REG		(0x34C8)
#define DSAF_XOD_RCVVC1_CNT_9_REG		(0x3558)
#define DSAF_XOD_RCVVC1_CNT_10_REG			(0x35E8)
#define DSAF_XOD_RCVVC1_CNT_11_REG			(0x3678)
#define DSAF_XOD_RCVVC1_CNT_12_REG			(0x3708)
#define DSAF_XOD_RCVVC1_CNT_13_REG			(0x3798)
#define DSAF_XOD_RCVVC1_CNT_14_REG			(0x3828)
#define DSAF_XOD_RCVVC1_CNT_15_REG			(0x38B8)
#define DSAF_XOD_RCVVC1_CNT_16_REG			(0x3948)
#define DSAF_XOD_RCVVC1_CNT_17_REG			(0x39D8)
#define DSAF_XOD_XGE_RCVIN0_CNT_0_REG	(0x304C)
#define DSAF_XOD_XGE_RCVIN0_CNT_1_REG	(0x30DC)
#define DSAF_XOD_XGE_RCVIN0_CNT_2_REG	(0x316C)
#define DSAF_XOD_XGE_RCVIN0_CNT_3_REG	(0x31FC)
#define DSAF_XOD_XGE_RCVIN0_CNT_4_REG	(0x328C)
#define DSAF_XOD_XGE_RCVIN0_CNT_5_REG	(0x331C)
#define DSAF_XOD_XGE_RCVIN1_CNT_0_REG	(0x3050)
#define DSAF_XOD_XGE_RCVIN1_CNT_1_REG	(0x30E0)
#define DSAF_XOD_XGE_RCVIN1_CNT_2_REG	(0x3170)
#define DSAF_XOD_XGE_RCVIN1_CNT_3_REG	(0x3200)
#define DSAF_XOD_XGE_RCVIN1_CNT_4_REG	(0x3290)
#define DSAF_XOD_XGE_RCVIN1_CNT_5_REG	(0x3320)
#define DSAF_XOD_XGE_RCVIN2_CNT_0_REG	(0x3054)
#define DSAF_XOD_XGE_RCVIN2_CNT_1_REG	(0x30E4)
#define DSAF_XOD_XGE_RCVIN2_CNT_2_REG	(0x3174)
#define DSAF_XOD_XGE_RCVIN2_CNT_3_REG	(0x3204)
#define DSAF_XOD_XGE_RCVIN2_CNT_4_REG	(0x3294)
#define DSAF_XOD_XGE_RCVIN2_CNT_5_REG	(0x3324)
#define DSAF_XOD_XGE_RCVIN3_CNT_0_REG	(0x3058)
#define DSAF_XOD_XGE_RCVIN3_CNT_1_REG	(0x30E8)
#define DSAF_XOD_XGE_RCVIN3_CNT_2_REG	(0x3178)
#define DSAF_XOD_XGE_RCVIN3_CNT_3_REG	(0x3208)
#define DSAF_XOD_XGE_RCVIN3_CNT_4_REG	(0x3298)
#define DSAF_XOD_XGE_RCVIN3_CNT_5_REG	(0x3328)
#define DSAF_XOD_XGE_RCVIN4_CNT_0_REG	(0x305C)
#define DSAF_XOD_XGE_RCVIN4_CNT_1_REG	(0x30EC)
#define DSAF_XOD_XGE_RCVIN4_CNT_2_REG	(0x317C)
#define DSAF_XOD_XGE_RCVIN4_CNT_3_REG	(0x320C)
#define DSAF_XOD_XGE_RCVIN4_CNT_4_REG	(0x329C)
#define DSAF_XOD_XGE_RCVIN4_CNT_5_REG	(0x332C)
#define DSAF_XOD_XGE_RCVIN5_CNT_0_REG	(0x3060)
#define DSAF_XOD_XGE_RCVIN5_CNT_1_REG	(0x30F0)
#define DSAF_XOD_XGE_RCVIN5_CNT_2_REG	(0x3180)
#define DSAF_XOD_XGE_RCVIN5_CNT_3_REG	(0x3210)
#define DSAF_XOD_XGE_RCVIN5_CNT_4_REG	(0x32A0)
#define DSAF_XOD_XGE_RCVIN5_CNT_5_REG	(0x3330)
#define DSAF_XOD_XGE_RCVIN6_CNT_0_REG	(0x3064)
#define DSAF_XOD_XGE_RCVIN6_CNT_1_REG	(0x30F4)
#define DSAF_XOD_XGE_RCVIN6_CNT_2_REG	(0x3184)
#define DSAF_XOD_XGE_RCVIN6_CNT_3_REG	(0x3214)
#define DSAF_XOD_XGE_RCVIN6_CNT_4_REG	(0x32A4)
#define DSAF_XOD_XGE_RCVIN6_CNT_5_REG	(0x3334)
#define DSAF_XOD_XGE_RCVIN7_CNT_0_REG	(0x3068)
#define DSAF_XOD_XGE_RCVIN7_CNT_1_REG	(0x30F8)
#define DSAF_XOD_XGE_RCVIN7_CNT_2_REG	(0x3188)
#define DSAF_XOD_XGE_RCVIN7_CNT_3_REG	(0x3218)
#define DSAF_XOD_XGE_RCVIN7_CNT_4_REG	(0x32A8)
#define DSAF_XOD_XGE_RCVIN7_CNT_5_REG	(0x3338)
#define DSAF_XOD_PPE_RCVIN0_CNT_0_REG	(0x306C)
#define DSAF_XOD_PPE_RCVIN0_CNT_1_REG	(0x30FC)
#define DSAF_XOD_PPE_RCVIN0_CNT_2_REG	(0x318C)
#define DSAF_XOD_PPE_RCVIN0_CNT_3_REG	(0x321C)
#define DSAF_XOD_PPE_RCVIN0_CNT_4_REG	(0x32AC)
#define DSAF_XOD_PPE_RCVIN0_CNT_5_REG	(0x333C)
#define DSAF_XOD_PPE_RCVIN1_CNT_0_REG	(0x3070)
#define DSAF_XOD_PPE_RCVIN1_CNT_1_REG	(0x3100)
#define DSAF_XOD_PPE_RCVIN1_CNT_2_REG	(0x3190)
#define DSAF_XOD_PPE_RCVIN1_CNT_3_REG	(0x3220)
#define DSAF_XOD_PPE_RCVIN1_CNT_4_REG	(0x32B0)
#define DSAF_XOD_PPE_RCVIN1_CNT_5_REG	(0x3340)
#define DSAF_XOD_ROCEE_RCVIN0_CNT_0_REG		   (0x3074)
#define DSAF_XOD_ROCEE_RCVIN0_CNT_1_REG		   (0x3104)
#define DSAF_XOD_ROCEE_RCVIN0_CNT_2_REG		   (0x3194)
#define DSAF_XOD_ROCEE_RCVIN0_CNT_3_REG		   (0x3224)
#define DSAF_XOD_ROCEE_RCVIN0_CNT_4_REG		   (0x32B4)
#define DSAF_XOD_ROCEE_RCVIN0_CNT_5_REG		   (0x3344)
#define DSAF_XOD_ROCEE_RCVIN1_CNT_0_REG		   (0x3078)
#define DSAF_XOD_ROCEE_RCVIN1_CNT_1_REG		   (0x3108)
#define DSAF_XOD_ROCEE_RCVIN1_CNT_2_REG		   (0x3198)
#define DSAF_XOD_ROCEE_RCVIN1_CNT_3_REG		   (0x3228)
#define DSAF_XOD_ROCEE_RCVIN1_CNT_4_REG		   (0x32B8)
#define DSAF_XOD_ROCEE_RCVIN1_CNT_5_REG		   (0x3348)
#define DSAF_XOD_FIFO_STATUS_0_REG			(0x307C)
#define DSAF_XOD_FIFO_STATUS_1_REG			(0x310C)
#define DSAF_XOD_FIFO_STATUS_2_REG			(0x319C)
#define DSAF_XOD_FIFO_STATUS_3_REG			(0x322C)
#define DSAF_XOD_FIFO_STATUS_4_REG			(0x32BC)
#define DSAF_XOD_FIFO_STATUS_5_REG			(0x334C)
#define DSAF_VOQ_ECC_INVERT_EN_0_REG		 (0x4004)
#define DSAF_VOQ_ECC_INVERT_EN_1_REG		 (0x4044)
#define DSAF_VOQ_ECC_INVERT_EN_2_REG		 (0x4084)
#define DSAF_VOQ_ECC_INVERT_EN_3_REG		 (0x40C4)
#define DSAF_VOQ_ECC_INVERT_EN_4_REG		 (0x4104)
#define DSAF_VOQ_ECC_INVERT_EN_5_REG		 (0x4144)
#define DSAF_VOQ_ECC_INVERT_EN_6_REG		 (0x4184)
#define DSAF_VOQ_ECC_INVERT_EN_7_REG		 (0x41C4)
#define DSAF_VOQ_ECC_INVERT_EN_8_REG		 (0x4204)
#define DSAF_VOQ_ECC_INVERT_EN_9_REG		 (0x4244)
#define DSAF_VOQ_ECC_INVERT_EN_10_REG	(0x4284)
#define DSAF_VOQ_ECC_INVERT_EN_11_REG	(0x42C4)
#define DSAF_VOQ_ECC_INVERT_EN_12_REG	(0x4304)
#define DSAF_VOQ_ECC_INVERT_EN_13_REG	(0x4344)
#define DSAF_VOQ_ECC_INVERT_EN_14_REG	(0x4384)
#define DSAF_VOQ_ECC_INVERT_EN_15_REG	(0x43C4)
#define DSAF_VOQ_ECC_INVERT_EN_16_REG	(0x4404)
#define DSAF_VOQ_ECC_INVERT_EN_17_REG	(0x4444)
#define DSAF_VOQ_SRAM_PKT_NUM_0_REG		  (0x4008)
#define DSAF_VOQ_SRAM_PKT_NUM_1_REG		  (0x4048)
#define DSAF_VOQ_SRAM_PKT_NUM_2_REG		  (0x4088)
#define DSAF_VOQ_SRAM_PKT_NUM_3_REG		  (0x40C8)
#define DSAF_VOQ_SRAM_PKT_NUM_4_REG		  (0x4108)
#define DSAF_VOQ_SRAM_PKT_NUM_5_REG		  (0x4148)
#define DSAF_VOQ_SRAM_PKT_NUM_6_REG		  (0x4188)
#define DSAF_VOQ_SRAM_PKT_NUM_7_REG		  (0x41C8)
#define DSAF_VOQ_SRAM_PKT_NUM_8_REG		  (0x4208)
#define DSAF_VOQ_SRAM_PKT_NUM_9_REG		  (0x4248)
#define DSAF_VOQ_SRAM_PKT_NUM_10_REG		 (0x4288)
#define DSAF_VOQ_SRAM_PKT_NUM_11_REG		 (0x42C8)
#define DSAF_VOQ_SRAM_PKT_NUM_12_REG		 (0x4308)
#define DSAF_VOQ_SRAM_PKT_NUM_13_REG		 (0x4348)
#define DSAF_VOQ_SRAM_PKT_NUM_14_REG		 (0x4388)
#define DSAF_VOQ_SRAM_PKT_NUM_15_REG		 (0x43C8)
#define DSAF_VOQ_SRAM_PKT_NUM_16_REG		 (0x4408)
#define DSAF_VOQ_SRAM_PKT_NUM_17_REG		 (0x4448)
#define DSAF_VOQ_IN_PKT_NUM_0_REG		(0x400C)
#define DSAF_VOQ_IN_PKT_NUM_1_REG		(0x404C)
#define DSAF_VOQ_IN_PKT_NUM_2_REG		(0x408C)
#define DSAF_VOQ_IN_PKT_NUM_3_REG		(0x40CC)
#define DSAF_VOQ_IN_PKT_NUM_4_REG		(0x410C)
#define DSAF_VOQ_IN_PKT_NUM_5_REG		(0x414C)
#define DSAF_VOQ_IN_PKT_NUM_6_REG		(0x418C)
#define DSAF_VOQ_IN_PKT_NUM_7_REG		(0x41CC)
#define DSAF_VOQ_IN_PKT_NUM_8_REG		(0x420C)
#define DSAF_VOQ_IN_PKT_NUM_9_REG		(0x424C)
#define DSAF_VOQ_IN_PKT_NUM_10_REG			(0x428C)
#define DSAF_VOQ_IN_PKT_NUM_11_REG			(0x42CC)
#define DSAF_VOQ_IN_PKT_NUM_12_REG			(0x430C)
#define DSAF_VOQ_IN_PKT_NUM_13_REG			(0x434C)
#define DSAF_VOQ_IN_PKT_NUM_14_REG			(0x438C)
#define DSAF_VOQ_IN_PKT_NUM_15_REG			(0x43CC)
#define DSAF_VOQ_IN_PKT_NUM_16_REG			(0x440C)
#define DSAF_VOQ_IN_PKT_NUM_17_REG			(0x444C)
#define DSAF_VOQ_OUT_PKT_NUM_0_REG			(0x4010)
#define DSAF_VOQ_OUT_PKT_NUM_1_REG			(0x4050)
#define DSAF_VOQ_OUT_PKT_NUM_2_REG			(0x4090)
#define DSAF_VOQ_OUT_PKT_NUM_3_REG			(0x40D0)
#define DSAF_VOQ_OUT_PKT_NUM_4_REG			(0x4110)
#define DSAF_VOQ_OUT_PKT_NUM_5_REG			(0x4150)
#define DSAF_VOQ_OUT_PKT_NUM_6_REG			(0x4190)
#define DSAF_VOQ_OUT_PKT_NUM_7_REG			(0x41D0)
#define DSAF_VOQ_OUT_PKT_NUM_8_REG			(0x4210)
#define DSAF_VOQ_OUT_PKT_NUM_9_REG			(0x4250)
#define DSAF_VOQ_OUT_PKT_NUM_10_REG		  (0x4290)
#define DSAF_VOQ_OUT_PKT_NUM_11_REG		  (0x42D0)
#define DSAF_VOQ_OUT_PKT_NUM_12_REG		  (0x4310)
#define DSAF_VOQ_OUT_PKT_NUM_13_REG		  (0x4350)
#define DSAF_VOQ_OUT_PKT_NUM_14_REG		  (0x4390)
#define DSAF_VOQ_OUT_PKT_NUM_15_REG		  (0x43D0)
#define DSAF_VOQ_OUT_PKT_NUM_16_REG		  (0x4410)
#define DSAF_VOQ_OUT_PKT_NUM_17_REG		  (0x4450)
#define DSAF_VOQ_ECC_ERR_ADDR_0_REG		  (0x4014)
#define DSAF_VOQ_ECC_ERR_ADDR_1_REG		  (0x4054)
#define DSAF_VOQ_ECC_ERR_ADDR_2_REG		  (0x4094)
#define DSAF_VOQ_ECC_ERR_ADDR_3_REG		  (0x40D4)
#define DSAF_VOQ_ECC_ERR_ADDR_4_REG		  (0x4114)
#define DSAF_VOQ_ECC_ERR_ADDR_5_REG		  (0x4154)
#define DSAF_VOQ_ECC_ERR_ADDR_6_REG		  (0x4194)
#define DSAF_VOQ_ECC_ERR_ADDR_7_REG		  (0x41D4)
#define DSAF_VOQ_ECC_ERR_ADDR_8_REG		  (0x4214)
#define DSAF_VOQ_ECC_ERR_ADDR_9_REG		  (0x4254)
#define DSAF_VOQ_ECC_ERR_ADDR_10_REG		 (0x4294)
#define DSAF_VOQ_ECC_ERR_ADDR_11_REG		 (0x42D4)
#define DSAF_VOQ_ECC_ERR_ADDR_12_REG		 (0x4314)
#define DSAF_VOQ_ECC_ERR_ADDR_13_REG		 (0x4354)
#define DSAF_VOQ_ECC_ERR_ADDR_14_REG		 (0x4394)
#define DSAF_VOQ_ECC_ERR_ADDR_15_REG		 (0x43D4)
#define DSAF_VOQ_ECC_ERR_ADDR_16_REG		 (0x4414)
#define DSAF_VOQ_ECC_ERR_ADDR_17_REG		 (0x4454)
#define DSAF_VOQ_BP_STATUS_0_REG	(0x4018)
#define DSAF_VOQ_BP_STATUS_1_REG	(0x4058)
#define DSAF_VOQ_BP_STATUS_2_REG	(0x4098)
#define DSAF_VOQ_BP_STATUS_3_REG	(0x40D8)
#define DSAF_VOQ_BP_STATUS_4_REG	(0x4118)
#define DSAF_VOQ_BP_STATUS_5_REG	(0x4158)
#define DSAF_VOQ_BP_STATUS_6_REG	(0x4198)
#define DSAF_VOQ_BP_STATUS_7_REG	(0x41D8)
#define DSAF_VOQ_BP_STATUS_8_REG	(0x4218)
#define DSAF_VOQ_BP_STATUS_9_REG	(0x4258)
#define DSAF_VOQ_BP_STATUS_10_REG		(0x4298)
#define DSAF_VOQ_BP_STATUS_11_REG		(0x42D8)
#define DSAF_VOQ_BP_STATUS_12_REG		(0x4318)
#define DSAF_VOQ_BP_STATUS_13_REG		(0x4358)
#define DSAF_VOQ_BP_STATUS_14_REG		(0x4398)
#define DSAF_VOQ_BP_STATUS_15_REG		(0x43D8)
#define DSAF_VOQ_BP_STATUS_16_REG		(0x4418)
#define DSAF_VOQ_BP_STATUS_17_REG		(0x4458)
#define DSAF_VOQ_SPUP_IDLE_0_REG	(0x401C)
#define DSAF_VOQ_SPUP_IDLE_1_REG	(0x405C)
#define DSAF_VOQ_SPUP_IDLE_2_REG	(0x409C)
#define DSAF_VOQ_SPUP_IDLE_3_REG	(0x40DC)
#define DSAF_VOQ_SPUP_IDLE_4_REG	(0x411C)
#define DSAF_VOQ_SPUP_IDLE_5_REG	(0x415C)
#define DSAF_VOQ_SPUP_IDLE_6_REG	(0x419C)
#define DSAF_VOQ_SPUP_IDLE_7_REG	(0x41DC)
#define DSAF_VOQ_SPUP_IDLE_8_REG	(0x421C)
#define DSAF_VOQ_SPUP_IDLE_9_REG	(0x425C)
#define DSAF_VOQ_SPUP_IDLE_10_REG		(0x429C)
#define DSAF_VOQ_SPUP_IDLE_11_REG		(0x42DC)
#define DSAF_VOQ_SPUP_IDLE_12_REG		(0x431C)
#define DSAF_VOQ_SPUP_IDLE_13_REG		(0x435C)
#define DSAF_VOQ_SPUP_IDLE_14_REG		(0x439C)
#define DSAF_VOQ_SPUP_IDLE_15_REG		(0x43DC)
#define DSAF_VOQ_SPUP_IDLE_16_REG		(0x441C)
#define DSAF_VOQ_SPUP_IDLE_17_REG		(0x445C)
#define DSAF_VOQ_XGE_XOD_REQ_0_0_REG		 (0x4024)
#define DSAF_VOQ_XGE_XOD_REQ_0_1_REG		 (0x4064)
#define DSAF_VOQ_XGE_XOD_REQ_0_2_REG		 (0x40A4)
#define DSAF_VOQ_XGE_XOD_REQ_0_3_REG		 (0x40E4)
#define DSAF_VOQ_XGE_XOD_REQ_0_4_REG		 (0x4124)
#define DSAF_VOQ_XGE_XOD_REQ_0_5_REG		 (0x4164)
#define DSAF_VOQ_XGE_XOD_REQ_1_0_REG		 (0x4028)
#define DSAF_VOQ_XGE_XOD_REQ_1_1_REG		 (0x4068)
#define DSAF_VOQ_XGE_XOD_REQ_1_2_REG		 (0x40A8)
#define DSAF_VOQ_XGE_XOD_REQ_1_3_REG		 (0x40E8)
#define DSAF_VOQ_XGE_XOD_REQ_1_4_REG		 (0x4128)
#define DSAF_VOQ_XGE_XOD_REQ_1_5_REG		 (0x4168)
#define DSAF_VOQ_PPE_XOD_REQ_0_REG			(0x402C)
#define DSAF_VOQ_PPE_XOD_REQ_1_REG			(0x406C)
#define DSAF_VOQ_PPE_XOD_REQ_2_REG			(0x40AC)
#define DSAF_VOQ_PPE_XOD_REQ_3_REG			(0x40EC)
#define DSAF_VOQ_PPE_XOD_REQ_4_REG			(0x412C)
#define DSAF_VOQ_PPE_XOD_REQ_5_REG			(0x416C)
#define DSAF_VOQ_ROCEE_XOD_REQ_0_REG		 (0x4030)
#define DSAF_VOQ_ROCEE_XOD_REQ_1_REG		 (0x4070)
#define DSAF_VOQ_ROCEE_XOD_REQ_2_REG		 (0x40B0)
#define DSAF_VOQ_ROCEE_XOD_REQ_3_REG		 (0x40F0)
#define DSAF_VOQ_ROCEE_XOD_REQ_4_REG		 (0x4130)
#define DSAF_VOQ_ROCEE_XOD_REQ_5_REG		 (0x4170)
#define DSAF_VOQ_BP_ALL_THRD_0_REG			(0x4034)
#define DSAF_VOQ_BP_ALL_THRD_1_REG			(0x4074)
#define DSAF_VOQ_BP_ALL_THRD_2_REG			(0x40B4)
#define DSAF_VOQ_BP_ALL_THRD_3_REG			(0x40F4)
#define DSAF_VOQ_BP_ALL_THRD_4_REG			(0x4134)
#define DSAF_VOQ_BP_ALL_THRD_5_REG			(0x4174)
#define DSAF_VOQ_BP_ALL_THRD_6_REG			(0x41B4)
#define DSAF_VOQ_BP_ALL_THRD_7_REG			(0x41F4)
#define DSAF_VOQ_BP_ALL_THRD_8_REG			(0x4234)
#define DSAF_VOQ_BP_ALL_THRD_9_REG			(0x4274)
#define DSAF_VOQ_BP_ALL_THRD_10_REG		  (0x42B4)
#define DSAF_VOQ_BP_ALL_THRD_11_REG		  (0x42F4)
#define DSAF_VOQ_BP_ALL_THRD_12_REG		  (0x4334)
#define DSAF_VOQ_BP_ALL_THRD_13_REG		  (0x4374)
#define DSAF_VOQ_BP_ALL_THRD_14_REG		  (0x43B4)
#define DSAF_VOQ_BP_ALL_THRD_15_REG		  (0x43F4)
#define DSAF_VOQ_BP_ALL_THRD_16_REG		  (0x4434)
#define DSAF_VOQ_BP_ALL_THRD_17_REG		  (0x4474)
#define DSAF_TBL_CTRL_0_REG			 (0x5000)
#define DSAF_TBL_INT_MSK_0_REG				(0x5004)
#define DSAF_TBL_INT_SRC_0_REG				(0x5008)
#define DSAF_TBL_INT_STS_0_REG				(0x5100)
#define DSAF_TBL_TCAM_ADDR_0_REG	(0x500C)
#define DSAF_TBL_LINE_ADDR_0_REG	(0x5010)
#define DSAF_TBL_TCAM_HIGH_0_REG	(0x5014)
#define DSAF_TBL_TCAM_LOW_0_REG		 (0x5018)
#define DSAF_TBL_TCAM_MCAST_CFG_4_0_REG		   (0x501C)
#define DSAF_TBL_TCAM_MCAST_CFG_3_0_REG		   (0x5020)
#define DSAF_TBL_TCAM_MCAST_CFG_2_0_REG		   (0x5024)
#define DSAF_TBL_TCAM_MCAST_CFG_1_0_REG		   (0x5028)
#define DSAF_TBL_TCAM_MCAST_CFG_0_0_REG		   (0x502C)
#define DSAF_TBL_TCAM_UCAST_CFG_0_REG	(0x5030)
#define DSAF_TBL_LIN_CFG_0_REG				(0x5034)
#define DSAF_TBL_TCAM_RDATA_HIGH_0_REG		(0x5038)
#define DSAF_TBL_TCAM_RDATA_LOW_0_REG	(0x503C)
#define DSAF_TBL_TCAM_RAM_RDATA4_0_REG		(0x5040)
#define DSAF_TBL_TCAM_RAM_RDATA3_0_REG		(0x5044)
#define DSAF_TBL_TCAM_RAM_RDATA2_0_REG		(0x5048)
#define DSAF_TBL_TCAM_RAM_RDATA1_0_REG		(0x504C)
#define DSAF_TBL_TCAM_RAM_RDATA0_0_REG		(0x5050)
#define DSAF_TBL_LIN_RDATA_0_REG	(0x5054)
#define DSAF_TBL_DA0_MIS_INFO1_0_REG		 (0x5058)
#define DSAF_TBL_DA0_MIS_INFO0_0_REG		 (0x505C)
#define DSAF_TBL_DA1_MIS_INFO1_0_REG		 (0x5060)
#define DSAF_TBL_DA1_MIS_INFO0_0_REG		 (0x5064)
#define DSAF_TBL_DA2_MIS_INFO1_0_REG		 (0x5068)
#define DSAF_TBL_DA2_MIS_INFO0_0_REG		 (0x506C)
#define DSAF_TBL_DA3_MIS_INFO1_0_REG		 (0x5070)
#define DSAF_TBL_DA3_MIS_INFO0_0_REG		 (0x5074)
#define DSAF_TBL_DA4_MIS_INFO1_0_REG		 (0x5078)
#define DSAF_TBL_DA4_MIS_INFO0_0_REG		 (0x507C)
#define DSAF_TBL_DA5_MIS_INFO1_0_REG		 (0x5080)
#define DSAF_TBL_DA5_MIS_INFO0_0_REG		 (0x5084)
#define DSAF_TBL_DA6_MIS_INFO1_0_REG		 (0x5088)
#define DSAF_TBL_DA6_MIS_INFO0_0_REG		 (0x508C)
#define DSAF_TBL_DA7_MIS_INFO1_0_REG		 (0x5090)
#define DSAF_TBL_DA7_MIS_INFO0_0_REG		 (0x5094)
#define DSAF_TBL_SA_MIS_INFO2_0_REG		  (0x5104)
#define DSAF_TBL_SA_MIS_INFO1_0_REG		  (0x5098)
#define DSAF_TBL_SA_MIS_INFO0_0_REG		  (0x509C)
#define DSAF_TBL_PUL_0_REG				(0x50A0)
#define DSAF_TBL_OLD_RSLT_0_REG		 (0x50A4)
#define DSAF_TBL_OLD_SCAN_VAL_0_REG		  (0x50A8)
#define DSAF_TBL_DFX_CTRL_0_REG		 (0x50AC)
#define DSAF_TBL_DFX_STAT_0_REG		 (0x50B0)
#define DSAF_TBL_DFX_STAT_2_0_REG		(0x5108)
#define DSAF_TBL_LKUP_NUM_I_0_REG		(0x50C0)
#define DSAF_TBL_LKUP_NUM_I_1_REG		(0x50C4)
#define DSAF_TBL_LKUP_NUM_I_2_REG		(0x50C8)
#define DSAF_TBL_LKUP_NUM_I_3_REG		(0x50CC)
#define DSAF_TBL_LKUP_NUM_I_4_REG		(0x50D0)
#define DSAF_TBL_LKUP_NUM_I_5_REG		(0x50D4)
#define DSAF_TBL_LKUP_NUM_I_6_REG		(0x50D8)
#define DSAF_TBL_LKUP_NUM_I_7_REG		(0x50DC)
#define DSAF_TBL_LKUP_NUM_O_0_REG		(0x50E0)
#define DSAF_TBL_LKUP_NUM_O_1_REG		(0x50E4)
#define DSAF_TBL_LKUP_NUM_O_2_REG		(0x50E8)
#define DSAF_TBL_LKUP_NUM_O_3_REG		(0x50EC)
#define DSAF_TBL_LKUP_NUM_O_4_REG		(0x50F0)
#define DSAF_TBL_LKUP_NUM_O_5_REG		(0x50F4)
#define DSAF_TBL_LKUP_NUM_O_6_REG		(0x50F8)
#define DSAF_TBL_LKUP_NUM_O_7_REG		(0x50FC)
#define DSAF_TBL_UCAST_BCAST_MIS_INFO_0_0_REG	 (0x510C)
#define DSAF_TBL_UCAST_BCAST_MIS_INFO_1_0_REG	 (0x5110)
#define DSAF_TBL_UCAST_BCAST_MIS_INFO_2_0_REG	 (0x5114)
#define DSAF_TBL_UCAST_BCAST_MIS_INFO_3_0_REG	 (0x5118)
#define DSAF_TBL_UCAST_BCAST_MIS_INFO_4_0_REG	 (0x511C)
#define DSAF_TBL_UCAST_BCAST_MIS_INFO_5_0_REG	 (0x5120)
#define DSAF_TBL_UCAST_BCAST_MIS_INFO_6_0_REG	 (0x5124)
#define DSAF_TBL_UCAST_BCAST_MIS_INFO_7_0_REG	 (0x5128)
#define DSAF_INODE_FIFO_WL_0_REG	(0x6000)
#define DSAF_INODE_FIFO_WL_1_REG	(0x6004)
#define DSAF_INODE_FIFO_WL_2_REG	(0x6008)
#define DSAF_INODE_FIFO_WL_3_REG	(0x600C)
#define DSAF_INODE_FIFO_WL_4_REG	(0x6010)
#define DSAF_INODE_FIFO_WL_5_REG	(0x6014)
#define DSAF_ONODE_FIFO_WL_0_REG	(0x6020)
#define DSAF_ONODE_FIFO_WL_1_REG	(0x6024)
#define DSAF_ONODE_FIFO_WL_2_REG	(0x6028)
#define DSAF_ONODE_FIFO_WL_3_REG	(0x602C)
#define DSAF_ONODE_FIFO_WL_4_REG	(0x6030)
#define DSAF_ONODE_FIFO_WL_5_REG	(0x6034)
#define DSAF_XGE_GE_WORK_MODE_0_REG		  (0x6040)
#define DSAF_XGE_GE_WORK_MODE_1_REG		  (0x6044)
#define DSAF_XGE_GE_WORK_MODE_2_REG		  (0x6048)
#define DSAF_XGE_GE_WORK_MODE_3_REG		  (0x604C)
#define DSAF_XGE_GE_WORK_MODE_4_REG		  (0x6050)
#define DSAF_XGE_GE_WORK_MODE_5_REG		  (0x6054)
#define DSAF_XGE_SDS_VSEMI_CHOOSE_0_REG		   (0x6060)
#define DSAF_XGE_APP_RX_LINK_UP_0_REG	(0x6080)
#define DSAF_XGE_APP_RX_LINK_UP_1_REG	(0x6084)
#define DSAF_XGE_APP_RX_LINK_UP_2_REG	(0x6088)
#define DSAF_XGE_APP_RX_LINK_UP_3_REG	(0x608C)
#define DSAF_XGE_APP_RX_LINK_UP_4_REG	(0x6090)
#define DSAF_XGE_APP_RX_LINK_UP_5_REG	(0x6094)
#define DSAF_NETPORT_CTRL_SIG_0_REG		  (0x60A0)
#define DSAF_NETPORT_CTRL_SIG_1_REG		  (0x60A4)
#define DSAF_NETPORT_CTRL_SIG_2_REG		  (0x60A8)
#define DSAF_NETPORT_CTRL_SIG_3_REG		  (0x60AC)
#define DSAF_NETPORT_CTRL_SIG_4_REG		  (0x60B0)
#define DSAF_NETPORT_CTRL_SIG_5_REG		  (0x60B4)
#define DSAF_XGE_CTRL_SIG_CFG_0_REG		  (0x60C0)
#define DSAF_XGE_CTRL_SIG_CFG_1_REG		  (0x60C4)
#define DSAF_XGE_CTRL_SIG_CFG_2_REG		  (0x60C8)
#define DSAF_XGE_CTRL_SIG_CFG_3_REG		  (0x60CC)
#define DSAF_XGE_CTRL_SIG_CFG_4_REG		  (0x60D0)
#define DSAF_XGE_CTRL_SIG_CFG_5_REG		  (0x60D4)

#endif /* _IWARE_DSAF_REG_OFFSET_H_ */

